/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 28 "conf_parser.y" /* yacc.c:339  */


#define YY_NO_UNPUT
#include <sys/types.h>
#include <string.h>

#include "config.h"
#include "stdinc.h"
#include "ircd.h"
#include "list.h"
#include "conf.h"
#include "conf_class.h"
#include "event.h"
#include "log.h"
#include "client.h"	/* for UMODE_ALL only */
#include "irc_string.h"
#include "memory.h"
#include "modules.h"
#include "s_serv.h"
#include "hostmask.h"
#include "send.h"
#include "listener.h"
#include "resv.h"
#include "numeric.h"
#include "s_user.h"
#include "motd.h"
#include "hook.h"
#include "ssl.h"

#include <openssl/rsa.h>
#include <openssl/bio.h>
#include <openssl/pem.h>
#include <openssl/dh.h>

#include "rsa.h"

int yylex(void);

static struct
{
  struct {
    dlink_list list;
  } mask,
    leaf,
    hub;

  struct {
    char buf[IRCD_BUFSIZE];
  } name,
    user,
    host,
    addr,
    bind,
    file,
    cert,
    ca,
    profile,
    rpass,
    spass,
    class,
    reason;

  struct {
    unsigned int value;
  } flags,
    modes,
    snomask_local,
    snomask_remote,
    size,
    type,
    port,
    aftype,
    ping_freq,
    max_perip,
    con_freq,
    min_idle,
    max_idle,
    max_total,
    max_global,
    max_local,
    soft_sendq,
    flood_burst,
    flood_limit,
    max_sendq,
    max_recvq,
    cidr_bitlen_ipv4,
    cidr_bitlen_ipv6,
    number_per_cidr,
    max_channels;

  struct
  {
    struct alias_entry *alias;
    struct sslprofile *ssl;
    struct sslprofile_identity *identity;
    struct dnsbl_entry *dnsbl;
    struct cloak_config *cloak;
  } ptr;
} block_state;

static void
reset_block_state(void)
{
  dlink_node *ptr = NULL, *ptr_next = NULL;

  DLINK_FOREACH_SAFE(ptr, ptr_next, block_state.mask.list.head)
  {
    MyFree(ptr->data);
    dlinkDelete(ptr, &block_state.mask.list);
    free_dlink_node(ptr);
  }

  DLINK_FOREACH_SAFE(ptr, ptr_next, block_state.leaf.list.head)
  {
    MyFree(ptr->data);
    dlinkDelete(ptr, &block_state.leaf.list);
    free_dlink_node(ptr);
  }

  DLINK_FOREACH_SAFE(ptr, ptr_next, block_state.hub.list.head)
  {
    MyFree(ptr->data);
    dlinkDelete(ptr, &block_state.hub.list);
    free_dlink_node(ptr);
  }

  memset(&block_state, 0, sizeof(block_state));
}


#line 197 "conf_parser.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_CONF_PARSER_H_INCLUDED
# define YY_YY_CONF_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    ACCEPT_PASSWORD = 258,
    ACCOUNT_WHOIS = 259,
    ADMIN = 260,
    AFTYPE = 261,
    ANTI_NICK_FLOOD = 262,
    ANTI_SPAM_EXIT_MESSAGE_TIME = 263,
    AUTOCONN = 264,
    BYTES = 265,
    KBYTES = 266,
    MBYTES = 267,
    CA_FILE = 268,
    CALLER_ID_WAIT = 269,
    CAN_FLOOD = 270,
    CHANNEL = 271,
    CIDR_BITLEN_IPV4 = 272,
    CIDR_BITLEN_IPV6 = 273,
    CIPHER_LIST = 274,
    CLASS = 275,
    CLOAK = 276,
    CLOAK_KEY = 277,
    CLOAK_KEY1 = 278,
    CLOAK_KEY2 = 279,
    CLOAK_KEY3 = 280,
    CONNECT = 281,
    CONNECTFREQ = 282,
    CYCLE_ON_HOST_CHANGE = 283,
    DEFAULT = 284,
    DEFAULT_FLOODCOUNT = 285,
    DEFAULT_FLOODTIME = 286,
    DEFAULT_SPLIT_SERVER_COUNT = 287,
    DEFAULT_SPLIT_USER_COUNT = 288,
    DEFER = 289,
    DELAY_SECS = 290,
    DELAY_MESSAGE_COUNT = 291,
    DELAY_SIGNON_SECS = 292,
    DENY = 293,
    DESCRIPTION = 294,
    DIE = 295,
    DISABLE_AUTH = 296,
    DISABLE_CHMODES = 297,
    DISABLE_FAKE_CHANNELS = 298,
    DISABLE_REMOTE_COMMANDS = 299,
    DNSBL = 300,
    DNSBL_EXEMPT = 301,
    DOTS_IN_IDENT = 302,
    DURATION = 303,
    EMAIL = 304,
    ENABLE_EXTBANS = 305,
    ENABLE_FORWARDING = 306,
    ENCRYPTED = 307,
    EXCEED_LIMIT = 308,
    EXEMPT = 309,
    FAILED_OPER_NOTICE = 310,
    FLATTEN_LINKS = 311,
    FLOOD_BURST = 312,
    FLOOD_LIMIT = 313,
    GECOS = 314,
    GENERAL = 315,
    GLINE = 316,
    GLINE_DURATION = 317,
    GLINE_ENABLE = 318,
    GLINE_EXEMPT = 319,
    GLINE_MIN_CIDR = 320,
    GLINE_MIN_CIDR6 = 321,
    GLINE_REQUEST_DURATION = 322,
    HAVENT_READ_CONF = 323,
    HIDDEN = 324,
    HIDDEN_NAME = 325,
    HIDE_IDLE_FROM_OPERS = 326,
    HIDE_SERVER_IPS = 327,
    HIDE_SERVERS = 328,
    HIDE_SERVICES = 329,
    HIDE_SPOOF_IPS = 330,
    HOST = 331,
    HTTP = 332,
    HUB = 333,
    HUB_MASK = 334,
    IDENTITY = 335,
    IGNORE_BOGUS_TS = 336,
    INVISIBLE_ON_CONNECT = 337,
    INVITE_THROTTLE = 338,
    IP = 339,
    IRCD_AUTH = 340,
    IRCD_FLAGS = 341,
    IRCD_SID = 342,
    JOIN_FLOOD_COUNT = 343,
    JOIN_FLOOD_TIME = 344,
    KILL = 345,
    KILL_CHASE_TIME_LIMIT = 346,
    KLINE = 347,
    KLINE_EXEMPT = 348,
    KLINE_REASON = 349,
    KNOCK_DELAY = 350,
    KNOCK_DELAY_CHANNEL = 351,
    LEAF_MASK = 352,
    T_LINK = 353,
    LINKS_DELAY = 354,
    LISTEN = 355,
    MASK = 356,
    MATCH = 357,
    MAX_ACCEPT = 358,
    MAX_BANS = 359,
    MAX_CHANNELS = 360,
    MAX_CHANS_PER_USER = 361,
    MAX_GLOBAL = 362,
    MAX_IDLE = 363,
    MAX_LOCAL = 364,
    MAX_NICK_CHANGES = 365,
    MAX_NICK_LENGTH = 366,
    MAX_NICK_TIME = 367,
    MAX_NUMBER = 368,
    MAX_TARGETS = 369,
    MAX_TOPIC_LENGTH = 370,
    MAX_WATCH = 371,
    MIN_IDLE = 372,
    MIN_NONWILDCARD = 373,
    MIN_NONWILDCARD_SIMPLE = 374,
    MODULE = 375,
    MODULES = 376,
    MOTD = 377,
    NAME = 378,
    NEED_ACCOUNT = 379,
    NEED_IDENT = 380,
    NEED_PASSWORD = 381,
    NETWORK_DESC = 382,
    NETWORK_NAME = 383,
    NICK = 384,
    NICK_COLLIDE_REALHOST = 385,
    NO_CREATE_ON_SPLIT = 386,
    NO_JOIN_ON_SPLIT = 387,
    NO_OPER_FLOOD = 388,
    NO_TILDE = 389,
    NUMBER = 390,
    NUMBER_PER_CIDR = 391,
    NUMBER_PER_IP = 392,
    OPER_ONLY = 393,
    OPER_ONLY_UMODES = 394,
    OPER_PASS_RESV = 395,
    OPER_SNOMASKS = 396,
    OPER_UMODES = 397,
    OPERATOR = 398,
    OPERS_BYPASS_CALLERID = 399,
    PACE_WAIT = 400,
    PACE_WAIT_SIMPLE = 401,
    PASSWORD = 402,
    PATH = 403,
    PING_COOKIE = 404,
    PING_TIME = 405,
    PORT = 406,
    QSTRING = 407,
    QUIET_ON_BAN = 408,
    RANDOM_IDLE = 409,
    REASON = 410,
    REDIRPORT = 411,
    REDIRSERV = 412,
    REHASH = 413,
    REMOTE = 414,
    REMOTEBAN = 415,
    RESV = 416,
    RESV_EXEMPT = 417,
    RSA_PRIVATE_KEY_FILE = 418,
    RSA_PUBLIC_KEY_FILE = 419,
    SECONDS = 420,
    MINUTES = 421,
    HOURS = 422,
    DAYS = 423,
    WEEKS = 424,
    MONTHS = 425,
    YEARS = 426,
    SEND_PASSWORD = 427,
    SENDQ = 428,
    SERVERHIDE = 429,
    SERVERINFO = 430,
    SERVER_NAME = 431,
    SESSION = 432,
    SHORT_MOTD = 433,
    T_SNOMASKS = 434,
    SOFT_SENDQ = 435,
    SPOOF = 436,
    SPOOF_NOTICE = 437,
    SQUIT = 438,
    SSL_CERTIFICATE_FILE = 439,
    SSL_CERTIFICATE_FINGERPRINT = 440,
    SSL_CONNECTION_REQUIRED = 441,
    SSL_DH_ELLIPTIC_CURVE = 442,
    SSL_DH_PARAM_FILE = 443,
    SSL_MESSAGE_DIGEST_ALGORITHM = 444,
    SSLPROFILE = 445,
    SSL_PROFILE = 446,
    STATS_E_DISABLED = 447,
    STATS_I_OPER_ONLY = 448,
    STATS_K_OPER_ONLY = 449,
    STATS_M_OPER_ONLY = 450,
    STATS_O_OPER_ONLY = 451,
    STATS_P_OPER_ONLY = 452,
    STATS_U_OPER_ONLY = 453,
    T_ALIAS = 454,
    T_ALL = 455,
    T_BOTS = 456,
    T_CALLERID = 457,
    T_CCONN = 458,
    T_CLUSTER = 459,
    T_DEAF = 460,
    T_DEBUG = 461,
    T_DLINE = 462,
    T_FARCONNECT = 463,
    T_FILE = 464,
    T_FULL = 465,
    T_HIDECHANNELS = 466,
    T_GLOBOPS = 467,
    T_INVISIBLE = 468,
    T_IPV4 = 469,
    T_IPV6 = 470,
    T_LOCOPS = 471,
    T_LOG = 472,
    T_MAX_CLIENTS = 473,
    T_NCHANGE = 474,
    T_NOCTCP = 475,
    T_NONONREG = 476,
    T_OPERWALL = 477,
    T_RECVQ = 478,
    T_REJ = 479,
    T_RESTART = 480,
    T_SASL_NAME = 481,
    T_SERVER = 482,
    T_SERVICE = 483,
    T_SERVICES_NAME = 484,
    T_SERVNOTICE = 485,
    T_SET = 486,
    T_SHARED = 487,
    T_SIZE = 488,
    T_SKILL = 489,
    T_SOFTCALLERID = 490,
    T_SPY = 491,
    T_SSL = 492,
    T_UMODES = 493,
    T_UNAUTH = 494,
    T_UNDLINE = 495,
    T_UNLIMITED = 496,
    T_UNRESV = 497,
    T_UNXLINE = 498,
    T_WALLOP = 499,
    T_WALLOPS = 500,
    T_WALLUSERS = 501,
    T_WEBIRC = 502,
    TBOOL = 503,
    THROTTLE_NUM = 504,
    THROTTLE_TIME = 505,
    TKLINE_EXPIRE_NOTICES = 506,
    TMASKED = 507,
    MASS_HIGHLIGHT_NICKS = 508,
    TS_MAX_DELTA = 509,
    TS_WARN_DELTA = 510,
    TWODOTS = 511,
    TYPE = 512,
    UNKLINE = 513,
    USE_LOGGING = 514,
    USE_TARGET_CHANGE = 515,
    USER = 516,
    VHOST = 517,
    VHOST6 = 518,
    WARN_NO_NLINE = 519,
    WLINE = 520,
    XLINE = 521
  };
#endif
/* Tokens.  */
#define ACCEPT_PASSWORD 258
#define ACCOUNT_WHOIS 259
#define ADMIN 260
#define AFTYPE 261
#define ANTI_NICK_FLOOD 262
#define ANTI_SPAM_EXIT_MESSAGE_TIME 263
#define AUTOCONN 264
#define BYTES 265
#define KBYTES 266
#define MBYTES 267
#define CA_FILE 268
#define CALLER_ID_WAIT 269
#define CAN_FLOOD 270
#define CHANNEL 271
#define CIDR_BITLEN_IPV4 272
#define CIDR_BITLEN_IPV6 273
#define CIPHER_LIST 274
#define CLASS 275
#define CLOAK 276
#define CLOAK_KEY 277
#define CLOAK_KEY1 278
#define CLOAK_KEY2 279
#define CLOAK_KEY3 280
#define CONNECT 281
#define CONNECTFREQ 282
#define CYCLE_ON_HOST_CHANGE 283
#define DEFAULT 284
#define DEFAULT_FLOODCOUNT 285
#define DEFAULT_FLOODTIME 286
#define DEFAULT_SPLIT_SERVER_COUNT 287
#define DEFAULT_SPLIT_USER_COUNT 288
#define DEFER 289
#define DELAY_SECS 290
#define DELAY_MESSAGE_COUNT 291
#define DELAY_SIGNON_SECS 292
#define DENY 293
#define DESCRIPTION 294
#define DIE 295
#define DISABLE_AUTH 296
#define DISABLE_CHMODES 297
#define DISABLE_FAKE_CHANNELS 298
#define DISABLE_REMOTE_COMMANDS 299
#define DNSBL 300
#define DNSBL_EXEMPT 301
#define DOTS_IN_IDENT 302
#define DURATION 303
#define EMAIL 304
#define ENABLE_EXTBANS 305
#define ENABLE_FORWARDING 306
#define ENCRYPTED 307
#define EXCEED_LIMIT 308
#define EXEMPT 309
#define FAILED_OPER_NOTICE 310
#define FLATTEN_LINKS 311
#define FLOOD_BURST 312
#define FLOOD_LIMIT 313
#define GECOS 314
#define GENERAL 315
#define GLINE 316
#define GLINE_DURATION 317
#define GLINE_ENABLE 318
#define GLINE_EXEMPT 319
#define GLINE_MIN_CIDR 320
#define GLINE_MIN_CIDR6 321
#define GLINE_REQUEST_DURATION 322
#define HAVENT_READ_CONF 323
#define HIDDEN 324
#define HIDDEN_NAME 325
#define HIDE_IDLE_FROM_OPERS 326
#define HIDE_SERVER_IPS 327
#define HIDE_SERVERS 328
#define HIDE_SERVICES 329
#define HIDE_SPOOF_IPS 330
#define HOST 331
#define HTTP 332
#define HUB 333
#define HUB_MASK 334
#define IDENTITY 335
#define IGNORE_BOGUS_TS 336
#define INVISIBLE_ON_CONNECT 337
#define INVITE_THROTTLE 338
#define IP 339
#define IRCD_AUTH 340
#define IRCD_FLAGS 341
#define IRCD_SID 342
#define JOIN_FLOOD_COUNT 343
#define JOIN_FLOOD_TIME 344
#define KILL 345
#define KILL_CHASE_TIME_LIMIT 346
#define KLINE 347
#define KLINE_EXEMPT 348
#define KLINE_REASON 349
#define KNOCK_DELAY 350
#define KNOCK_DELAY_CHANNEL 351
#define LEAF_MASK 352
#define T_LINK 353
#define LINKS_DELAY 354
#define LISTEN 355
#define MASK 356
#define MATCH 357
#define MAX_ACCEPT 358
#define MAX_BANS 359
#define MAX_CHANNELS 360
#define MAX_CHANS_PER_USER 361
#define MAX_GLOBAL 362
#define MAX_IDLE 363
#define MAX_LOCAL 364
#define MAX_NICK_CHANGES 365
#define MAX_NICK_LENGTH 366
#define MAX_NICK_TIME 367
#define MAX_NUMBER 368
#define MAX_TARGETS 369
#define MAX_TOPIC_LENGTH 370
#define MAX_WATCH 371
#define MIN_IDLE 372
#define MIN_NONWILDCARD 373
#define MIN_NONWILDCARD_SIMPLE 374
#define MODULE 375
#define MODULES 376
#define MOTD 377
#define NAME 378
#define NEED_ACCOUNT 379
#define NEED_IDENT 380
#define NEED_PASSWORD 381
#define NETWORK_DESC 382
#define NETWORK_NAME 383
#define NICK 384
#define NICK_COLLIDE_REALHOST 385
#define NO_CREATE_ON_SPLIT 386
#define NO_JOIN_ON_SPLIT 387
#define NO_OPER_FLOOD 388
#define NO_TILDE 389
#define NUMBER 390
#define NUMBER_PER_CIDR 391
#define NUMBER_PER_IP 392
#define OPER_ONLY 393
#define OPER_ONLY_UMODES 394
#define OPER_PASS_RESV 395
#define OPER_SNOMASKS 396
#define OPER_UMODES 397
#define OPERATOR 398
#define OPERS_BYPASS_CALLERID 399
#define PACE_WAIT 400
#define PACE_WAIT_SIMPLE 401
#define PASSWORD 402
#define PATH 403
#define PING_COOKIE 404
#define PING_TIME 405
#define PORT 406
#define QSTRING 407
#define QUIET_ON_BAN 408
#define RANDOM_IDLE 409
#define REASON 410
#define REDIRPORT 411
#define REDIRSERV 412
#define REHASH 413
#define REMOTE 414
#define REMOTEBAN 415
#define RESV 416
#define RESV_EXEMPT 417
#define RSA_PRIVATE_KEY_FILE 418
#define RSA_PUBLIC_KEY_FILE 419
#define SECONDS 420
#define MINUTES 421
#define HOURS 422
#define DAYS 423
#define WEEKS 424
#define MONTHS 425
#define YEARS 426
#define SEND_PASSWORD 427
#define SENDQ 428
#define SERVERHIDE 429
#define SERVERINFO 430
#define SERVER_NAME 431
#define SESSION 432
#define SHORT_MOTD 433
#define T_SNOMASKS 434
#define SOFT_SENDQ 435
#define SPOOF 436
#define SPOOF_NOTICE 437
#define SQUIT 438
#define SSL_CERTIFICATE_FILE 439
#define SSL_CERTIFICATE_FINGERPRINT 440
#define SSL_CONNECTION_REQUIRED 441
#define SSL_DH_ELLIPTIC_CURVE 442
#define SSL_DH_PARAM_FILE 443
#define SSL_MESSAGE_DIGEST_ALGORITHM 444
#define SSLPROFILE 445
#define SSL_PROFILE 446
#define STATS_E_DISABLED 447
#define STATS_I_OPER_ONLY 448
#define STATS_K_OPER_ONLY 449
#define STATS_M_OPER_ONLY 450
#define STATS_O_OPER_ONLY 451
#define STATS_P_OPER_ONLY 452
#define STATS_U_OPER_ONLY 453
#define T_ALIAS 454
#define T_ALL 455
#define T_BOTS 456
#define T_CALLERID 457
#define T_CCONN 458
#define T_CLUSTER 459
#define T_DEAF 460
#define T_DEBUG 461
#define T_DLINE 462
#define T_FARCONNECT 463
#define T_FILE 464
#define T_FULL 465
#define T_HIDECHANNELS 466
#define T_GLOBOPS 467
#define T_INVISIBLE 468
#define T_IPV4 469
#define T_IPV6 470
#define T_LOCOPS 471
#define T_LOG 472
#define T_MAX_CLIENTS 473
#define T_NCHANGE 474
#define T_NOCTCP 475
#define T_NONONREG 476
#define T_OPERWALL 477
#define T_RECVQ 478
#define T_REJ 479
#define T_RESTART 480
#define T_SASL_NAME 481
#define T_SERVER 482
#define T_SERVICE 483
#define T_SERVICES_NAME 484
#define T_SERVNOTICE 485
#define T_SET 486
#define T_SHARED 487
#define T_SIZE 488
#define T_SKILL 489
#define T_SOFTCALLERID 490
#define T_SPY 491
#define T_SSL 492
#define T_UMODES 493
#define T_UNAUTH 494
#define T_UNDLINE 495
#define T_UNLIMITED 496
#define T_UNRESV 497
#define T_UNXLINE 498
#define T_WALLOP 499
#define T_WALLOPS 500
#define T_WALLUSERS 501
#define T_WEBIRC 502
#define TBOOL 503
#define THROTTLE_NUM 504
#define THROTTLE_TIME 505
#define TKLINE_EXPIRE_NOTICES 506
#define TMASKED 507
#define MASS_HIGHLIGHT_NICKS 508
#define TS_MAX_DELTA 509
#define TS_WARN_DELTA 510
#define TWODOTS 511
#define TYPE 512
#define UNKLINE 513
#define USE_LOGGING 514
#define USE_TARGET_CHANGE 515
#define USER 516
#define VHOST 517
#define VHOST6 518
#define WARN_NO_NLINE 519
#define WLINE 520
#define XLINE 521

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 159 "conf_parser.y" /* yacc.c:355  */

  int number;
  char *string;

#line 774 "conf_parser.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_CONF_PARSER_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 791 "conf_parser.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1645

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  273
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  354
/* YYNRULES -- Number of rules.  */
#define YYNRULES  775
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1554

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   521

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,   271,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   272,   267,
       2,   270,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   269,     2,   268,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   429,   429,   430,   433,   434,   435,   436,   437,   438,
     439,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   452,   453,   454,   455,   456,   457,   458,
     459,   463,   463,   464,   468,   472,   476,   480,   484,   488,
     492,   498,   498,   499,   500,   501,   502,   509,   508,   523,
     523,   524,   524,   524,   524,   524,   526,   539,   545,   551,
     563,   566,   566,   567,   567,   567,   569,   575,   583,   582,
     631,   631,   632,   632,   632,   633,   633,   634,   635,   637,
     645,   677,   703,   711,   720,   719,   741,   741,   742,   742,
     743,   744,   746,   761,   821,   862,   864,   864,   865,   865,
     866,   866,   867,   867,   868,   868,   869,   870,   871,   872,
     875,   890,   905,   914,   928,   937,   965,   995,  1020,  1042,
    1064,  1073,  1075,  1075,  1076,  1076,  1077,  1077,  1079,  1088,
    1097,  1110,  1109,  1127,  1127,  1128,  1128,  1128,  1130,  1136,
    1147,  1146,  1172,  1172,  1174,  1174,  1174,  1174,  1176,  1182,
    1188,  1189,  1189,  1190,  1217,  1216,  1233,  1233,  1234,  1235,
    1236,  1237,  1238,  1239,  1240,  1242,  1248,  1254,  1265,  1276,
    1287,  1301,  1302,  1302,  1304,  1304,  1305,  1307,  1314,  1314,
    1327,  1328,  1330,  1330,  1331,  1331,  1333,  1341,  1344,  1350,
    1349,  1355,  1355,  1356,  1360,  1364,  1368,  1372,  1376,  1380,
    1384,  1388,  1399,  1398,  1479,  1479,  1480,  1480,  1480,  1481,
    1481,  1481,  1481,  1482,  1482,  1483,  1484,  1484,  1486,  1492,
    1498,  1504,  1515,  1521,  1527,  1538,  1545,  1544,  1550,  1550,
    1551,  1552,  1557,  1562,  1567,  1572,  1577,  1582,  1587,  1592,
    1597,  1602,  1607,  1614,  1613,  1619,  1619,  1621,  1626,  1631,
    1636,  1641,  1646,  1651,  1656,  1661,  1666,  1671,  1676,  1681,
    1688,  1687,  1693,  1693,  1694,  1698,  1702,  1706,  1710,  1714,
    1718,  1722,  1726,  1730,  1734,  1738,  1742,  1746,  1750,  1754,
    1758,  1762,  1766,  1770,  1774,  1778,  1782,  1786,  1790,  1794,
    1798,  1809,  1808,  1866,  1866,  1867,  1868,  1868,  1869,  1870,
    1871,  1872,  1873,  1874,  1875,  1876,  1876,  1876,  1876,  1876,
    1877,  1878,  1879,  1880,  1881,  1883,  1889,  1895,  1901,  1907,
    1913,  1919,  1925,  1931,  1937,  1943,  1949,  1956,  1962,  1968,
    1974,  1983,  1992,  1999,  1998,  2004,  2004,  2005,  2009,  2020,
    2019,  2026,  2025,  2031,  2031,  2032,  2036,  2040,  2044,  2048,
    2054,  2054,  2055,  2055,  2055,  2055,  2055,  2055,  2058,  2057,
    2063,  2063,  2065,  2084,  2107,  2113,  2119,  2129,  2128,  2193,
    2193,  2194,  2194,  2194,  2194,  2195,  2195,  2195,  2196,  2196,
    2197,  2197,  2199,  2205,  2211,  2217,  2229,  2228,  2234,  2234,
    2235,  2239,  2243,  2247,  2251,  2255,  2259,  2263,  2267,  2271,
    2275,  2279,  2285,  2299,  2308,  2317,  2325,  2338,  2337,  2352,
    2352,  2353,  2353,  2353,  2353,  2355,  2361,  2367,  2377,  2379,
    2379,  2380,  2380,  2382,  2398,  2397,  2422,  2422,  2423,  2423,
    2423,  2423,  2425,  2431,  2451,  2450,  2456,  2456,  2457,  2461,
    2465,  2469,  2473,  2477,  2481,  2485,  2489,  2493,  2497,  2501,
    2511,  2510,  2531,  2531,  2532,  2532,  2532,  2534,  2541,  2540,
    2546,  2546,  2547,  2551,  2555,  2559,  2563,  2567,  2571,  2575,
    2579,  2583,  2593,  2592,  2679,  2679,  2680,  2680,  2680,  2681,
    2681,  2682,  2682,  2682,  2683,  2683,  2684,  2684,  2684,  2685,
    2685,  2686,  2688,  2694,  2700,  2706,  2719,  2732,  2738,  2744,
    2750,  2756,  2760,  2769,  2768,  2773,  2773,  2774,  2778,  2784,
    2795,  2801,  2807,  2818,  2817,  2843,  2843,  2844,  2844,  2844,
    2846,  2866,  2876,  2875,  2902,  2902,  2903,  2903,  2903,  2905,
    2911,  2920,  2922,  2922,  2923,  2923,  2925,  2943,  2942,  2965,
    2965,  2966,  2966,  2966,  2968,  2974,  2983,  2986,  2986,  2987,
    2987,  2988,  2988,  2989,  2989,  2990,  2990,  2991,  2991,  2992,
    2993,  2994,  2994,  2995,  2995,  2996,  2996,  2996,  2997,  2997,
    2998,  2999,  2999,  3000,  3001,  3001,  3002,  3002,  3002,  3003,
    3003,  3003,  3004,  3004,  3005,  3005,  3005,  3006,  3006,  3007,
    3008,  3008,  3009,  3009,  3010,  3011,  3012,  3013,  3014,  3014,
    3014,  3015,  3016,  3017,  3017,  3017,  3018,  3018,  3018,  3019,
    3019,  3019,  3019,  3020,  3023,  3028,  3034,  3043,  3049,  3055,
    3061,  3067,  3072,  3077,  3086,  3091,  3096,  3101,  3106,  3111,
    3116,  3121,  3126,  3131,  3136,  3141,  3147,  3158,  3163,  3168,
    3173,  3178,  3183,  3188,  3191,  3196,  3199,  3204,  3209,  3214,
    3219,  3224,  3229,  3234,  3239,  3244,  3249,  3254,  3263,  3272,
    3277,  3282,  3287,  3292,  3298,  3297,  3302,  3307,  3312,  3324,
    3329,  3334,  3339,  3344,  3344,  3345,  3349,  3353,  3357,  3361,
    3365,  3369,  3373,  3377,  3381,  3385,  3389,  3395,  3394,  3399,
    3399,  3401,  3405,  3409,  3413,  3417,  3421,  3425,  3429,  3433,
    3437,  3441,  3445,  3449,  3455,  3454,  3459,  3459,  3460,  3464,
    3468,  3472,  3476,  3480,  3484,  3488,  3492,  3496,  3500,  3504,
    3509,  3518,  3523,  3528,  3533,  3538,  3547,  3550,  3550,  3551,
    3552,  3552,  3553,  3554,  3555,  3556,  3557,  3558,  3558,  3559,
    3559,  3560,  3560,  3562,  3567,  3572,  3577,  3582,  3587,  3592,
    3597,  3602,  3607,  3612,  3617,  3622,  3630,  3633,  3633,  3634,
    3634,  3635,  3636,  3637,  3638,  3638,  3639,  3640,  3642,  3648,
    3654,  3660,  3666,  3675,  3689,  3695
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ACCEPT_PASSWORD", "ACCOUNT_WHOIS",
  "ADMIN", "AFTYPE", "ANTI_NICK_FLOOD", "ANTI_SPAM_EXIT_MESSAGE_TIME",
  "AUTOCONN", "BYTES", "KBYTES", "MBYTES", "CA_FILE", "CALLER_ID_WAIT",
  "CAN_FLOOD", "CHANNEL", "CIDR_BITLEN_IPV4", "CIDR_BITLEN_IPV6",
  "CIPHER_LIST", "CLASS", "CLOAK", "CLOAK_KEY", "CLOAK_KEY1", "CLOAK_KEY2",
  "CLOAK_KEY3", "CONNECT", "CONNECTFREQ", "CYCLE_ON_HOST_CHANGE",
  "DEFAULT", "DEFAULT_FLOODCOUNT", "DEFAULT_FLOODTIME",
  "DEFAULT_SPLIT_SERVER_COUNT", "DEFAULT_SPLIT_USER_COUNT", "DEFER",
  "DELAY_SECS", "DELAY_MESSAGE_COUNT", "DELAY_SIGNON_SECS", "DENY",
  "DESCRIPTION", "DIE", "DISABLE_AUTH", "DISABLE_CHMODES",
  "DISABLE_FAKE_CHANNELS", "DISABLE_REMOTE_COMMANDS", "DNSBL",
  "DNSBL_EXEMPT", "DOTS_IN_IDENT", "DURATION", "EMAIL", "ENABLE_EXTBANS",
  "ENABLE_FORWARDING", "ENCRYPTED", "EXCEED_LIMIT", "EXEMPT",
  "FAILED_OPER_NOTICE", "FLATTEN_LINKS", "FLOOD_BURST", "FLOOD_LIMIT",
  "GECOS", "GENERAL", "GLINE", "GLINE_DURATION", "GLINE_ENABLE",
  "GLINE_EXEMPT", "GLINE_MIN_CIDR", "GLINE_MIN_CIDR6",
  "GLINE_REQUEST_DURATION", "HAVENT_READ_CONF", "HIDDEN", "HIDDEN_NAME",
  "HIDE_IDLE_FROM_OPERS", "HIDE_SERVER_IPS", "HIDE_SERVERS",
  "HIDE_SERVICES", "HIDE_SPOOF_IPS", "HOST", "HTTP", "HUB", "HUB_MASK",
  "IDENTITY", "IGNORE_BOGUS_TS", "INVISIBLE_ON_CONNECT", "INVITE_THROTTLE",
  "IP", "IRCD_AUTH", "IRCD_FLAGS", "IRCD_SID", "JOIN_FLOOD_COUNT",
  "JOIN_FLOOD_TIME", "KILL", "KILL_CHASE_TIME_LIMIT", "KLINE",
  "KLINE_EXEMPT", "KLINE_REASON", "KNOCK_DELAY", "KNOCK_DELAY_CHANNEL",
  "LEAF_MASK", "T_LINK", "LINKS_DELAY", "LISTEN", "MASK", "MATCH",
  "MAX_ACCEPT", "MAX_BANS", "MAX_CHANNELS", "MAX_CHANS_PER_USER",
  "MAX_GLOBAL", "MAX_IDLE", "MAX_LOCAL", "MAX_NICK_CHANGES",
  "MAX_NICK_LENGTH", "MAX_NICK_TIME", "MAX_NUMBER", "MAX_TARGETS",
  "MAX_TOPIC_LENGTH", "MAX_WATCH", "MIN_IDLE", "MIN_NONWILDCARD",
  "MIN_NONWILDCARD_SIMPLE", "MODULE", "MODULES", "MOTD", "NAME",
  "NEED_ACCOUNT", "NEED_IDENT", "NEED_PASSWORD", "NETWORK_DESC",
  "NETWORK_NAME", "NICK", "NICK_COLLIDE_REALHOST", "NO_CREATE_ON_SPLIT",
  "NO_JOIN_ON_SPLIT", "NO_OPER_FLOOD", "NO_TILDE", "NUMBER",
  "NUMBER_PER_CIDR", "NUMBER_PER_IP", "OPER_ONLY", "OPER_ONLY_UMODES",
  "OPER_PASS_RESV", "OPER_SNOMASKS", "OPER_UMODES", "OPERATOR",
  "OPERS_BYPASS_CALLERID", "PACE_WAIT", "PACE_WAIT_SIMPLE", "PASSWORD",
  "PATH", "PING_COOKIE", "PING_TIME", "PORT", "QSTRING", "QUIET_ON_BAN",
  "RANDOM_IDLE", "REASON", "REDIRPORT", "REDIRSERV", "REHASH", "REMOTE",
  "REMOTEBAN", "RESV", "RESV_EXEMPT", "RSA_PRIVATE_KEY_FILE",
  "RSA_PUBLIC_KEY_FILE", "SECONDS", "MINUTES", "HOURS", "DAYS", "WEEKS",
  "MONTHS", "YEARS", "SEND_PASSWORD", "SENDQ", "SERVERHIDE", "SERVERINFO",
  "SERVER_NAME", "SESSION", "SHORT_MOTD", "T_SNOMASKS", "SOFT_SENDQ",
  "SPOOF", "SPOOF_NOTICE", "SQUIT", "SSL_CERTIFICATE_FILE",
  "SSL_CERTIFICATE_FINGERPRINT", "SSL_CONNECTION_REQUIRED",
  "SSL_DH_ELLIPTIC_CURVE", "SSL_DH_PARAM_FILE",
  "SSL_MESSAGE_DIGEST_ALGORITHM", "SSLPROFILE", "SSL_PROFILE",
  "STATS_E_DISABLED", "STATS_I_OPER_ONLY", "STATS_K_OPER_ONLY",
  "STATS_M_OPER_ONLY", "STATS_O_OPER_ONLY", "STATS_P_OPER_ONLY",
  "STATS_U_OPER_ONLY", "T_ALIAS", "T_ALL", "T_BOTS", "T_CALLERID",
  "T_CCONN", "T_CLUSTER", "T_DEAF", "T_DEBUG", "T_DLINE", "T_FARCONNECT",
  "T_FILE", "T_FULL", "T_HIDECHANNELS", "T_GLOBOPS", "T_INVISIBLE",
  "T_IPV4", "T_IPV6", "T_LOCOPS", "T_LOG", "T_MAX_CLIENTS", "T_NCHANGE",
  "T_NOCTCP", "T_NONONREG", "T_OPERWALL", "T_RECVQ", "T_REJ", "T_RESTART",
  "T_SASL_NAME", "T_SERVER", "T_SERVICE", "T_SERVICES_NAME",
  "T_SERVNOTICE", "T_SET", "T_SHARED", "T_SIZE", "T_SKILL",
  "T_SOFTCALLERID", "T_SPY", "T_SSL", "T_UMODES", "T_UNAUTH", "T_UNDLINE",
  "T_UNLIMITED", "T_UNRESV", "T_UNXLINE", "T_WALLOP", "T_WALLOPS",
  "T_WALLUSERS", "T_WEBIRC", "TBOOL", "THROTTLE_NUM", "THROTTLE_TIME",
  "TKLINE_EXPIRE_NOTICES", "TMASKED", "MASS_HIGHLIGHT_NICKS",
  "TS_MAX_DELTA", "TS_WARN_DELTA", "TWODOTS", "TYPE", "UNKLINE",
  "USE_LOGGING", "USE_TARGET_CHANGE", "USER", "VHOST", "VHOST6",
  "WARN_NO_NLINE", "WLINE", "XLINE", "';'", "'}'", "'{'", "'='", "','",
  "':'", "$accept", "conf", "conf_item", "timespec_", "timespec",
  "sizespec_", "sizespec", "alias_entry", "$@1", "alias_items",
  "alias_item", "alias_name", "alias_user", "alias_host",
  "alias_oper_only", "modules_entry", "modules_items", "modules_item",
  "modules_module", "modules_path", "sslprofile", "$@2",
  "sslprofile_items", "sslprofile_item", "sslprofile_name",
  "sslprofile_dh_param_file", "sslprofile_dh_elliptic_curve",
  "sslprofile_cipher_list", "sslprofile_cafile", "sslprofile_identity",
  "$@3", "sslprofile_identity_items", "sslprofile_identity_item",
  "sslprofile_identity_server_name",
  "sslprofile_identity_rsa_private_key_file",
  "sslprofile_identity_certificate_file", "serverinfo_entry",
  "serverinfo_items", "serverinfo_item", "serverinfo_name",
  "serverinfo_sid", "serverinfo_description", "serverinfo_network_name",
  "serverinfo_network_desc", "serverinfo_vhost", "serverinfo_vhost6",
  "serverinfo_max_clients", "serverinfo_max_nick_length",
  "serverinfo_max_topic_length", "serverinfo_hub", "admin_entry",
  "admin_items", "admin_item", "admin_name", "admin_email",
  "admin_description", "motd_entry", "$@4", "motd_items", "motd_item",
  "motd_mask", "motd_file", "dnsbl_entry", "$@5", "dnsbl_items",
  "dnsbl_item", "dnsbl_name", "dnsbl_reason", "dnsbl_matches",
  "match_items", "match_item", "cloak_entry", "$@6", "cloak_items",
  "cloak_item", "cloak_name", "cloak_default", "cloak_key", "cloak_key1",
  "cloak_key2", "cloak_key3", "logging_entry", "logging_items",
  "logging_item", "logging_use_logging", "logging_file_entry", "$@7",
  "logging_file_items", "logging_file_item", "logging_file_name",
  "logging_file_size", "logging_file_type", "$@8",
  "logging_file_type_items", "logging_file_type_item", "oper_entry", "$@9",
  "oper_items", "oper_item", "oper_name", "oper_user", "oper_password",
  "oper_encrypted", "oper_rsa_public_key_file",
  "oper_ssl_certificate_fingerprint", "oper_ssl_connection_required",
  "oper_class", "oper_umodes", "$@10", "oper_umodes_items",
  "oper_umodes_item", "oper_snomasks", "$@11", "oper_snomasks_items",
  "oper_snomasks_item", "oper_flags", "$@12", "oper_flags_items",
  "oper_flags_item", "class_entry", "$@13", "class_items", "class_item",
  "class_name", "class_ping_time", "class_number_per_ip",
  "class_connectfreq", "class_max_number", "class_max_global",
  "class_max_local", "class_soft_sendq", "class_flood_burst",
  "class_flood_limit", "class_sendq", "class_recvq",
  "class_cidr_bitlen_ipv4", "class_cidr_bitlen_ipv6",
  "class_number_per_cidr", "class_min_idle", "class_max_idle",
  "class_max_channels", "class_flags", "$@14", "class_flags_items",
  "class_flags_item", "listen_entry", "$@15", "listen_flags", "$@16",
  "listen_flags_items", "listen_flags_item", "listen_items", "listen_item",
  "listen_port", "$@17", "port_items", "port_item", "listen_address",
  "listen_host", "listen_ssl_profile", "auth_entry", "$@18", "auth_items",
  "auth_item", "auth_user", "auth_passwd", "auth_class", "auth_encrypted",
  "auth_flags", "$@19", "auth_flags_items", "auth_flags_item",
  "auth_spoof", "auth_redir_serv", "auth_redir_port",
  "auth_ssl_certificate_fingerprint", "auth_ca_file", "resv_entry", "$@20",
  "resv_items", "resv_item", "resv_mask", "resv_reason", "resv_exempt",
  "service_entry", "service_items", "service_item", "service_name",
  "shared_entry", "$@21", "shared_items", "shared_item", "shared_name",
  "shared_user", "shared_type", "$@22", "shared_types", "shared_type_item",
  "cluster_entry", "$@23", "cluster_items", "cluster_item", "cluster_name",
  "cluster_type", "$@24", "cluster_types", "cluster_type_item",
  "connect_entry", "$@25", "connect_items", "connect_item", "connect_name",
  "connect_host", "connect_vhost", "connect_send_password",
  "connect_accept_password", "connect_ssl_certificate_fingerprint",
  "connect_ca_file", "connect_ssl_profile", "connect_port",
  "connect_aftype", "connect_flags", "$@26", "connect_flags_items",
  "connect_flags_item", "connect_encrypted", "connect_hub_mask",
  "connect_leaf_mask", "connect_class", "kill_entry", "$@27", "kill_items",
  "kill_item", "kill_user", "kill_reason", "deny_entry", "$@28",
  "deny_items", "deny_item", "deny_ip", "deny_reason", "exempt_entry",
  "exempt_items", "exempt_item", "exempt_ip", "gecos_entry", "$@29",
  "gecos_items", "gecos_item", "gecos_name", "gecos_reason",
  "general_entry", "general_items", "general_item", "general_max_watch",
  "general_cycle_on_host_change", "general_cloak_key",
  "general_account_whois", "general_gline_enable",
  "general_gline_duration", "general_gline_request_duration",
  "general_gline_min_cidr", "general_gline_min_cidr6",
  "general_kline_reason", "general_tkline_expire_notices",
  "general_kill_chase_time_limit", "general_hide_spoof_ips",
  "general_ignore_bogus_ts", "general_failed_oper_notice",
  "general_anti_nick_flood", "general_max_nick_time",
  "general_max_nick_changes", "general_max_accept",
  "general_anti_spam_exit_message_time", "general_ts_warn_delta",
  "general_ts_max_delta", "general_havent_read_conf",
  "general_invisible_on_connect", "general_warn_no_nline",
  "general_stats_e_disabled", "general_stats_o_oper_only",
  "general_stats_P_oper_only", "general_stats_u_oper_only",
  "general_stats_k_oper_only", "general_stats_i_oper_only",
  "general_stats_m_oper_only", "general_pace_wait",
  "general_caller_id_wait", "general_opers_bypass_callerid",
  "general_pace_wait_simple", "general_short_motd",
  "general_no_oper_flood", "general_oper_pass_resv",
  "general_dots_in_ident", "general_max_targets", "general_services_name",
  "general_sasl_name", "general_ping_cookie",
  "general_nick_collide_realhost", "general_disable_auth",
  "general_throttle_num", "general_throttle_time", "general_oper_umodes",
  "$@30", "general_enable_extbans", "general_enable_forwarding",
  "general_ssl_message_digest_algorithm", "general_mass_highlight_nicks",
  "general_delay_secs", "general_delay_message_count",
  "general_delay_signon_secs", "umode_oitems", "umode_oitem",
  "general_oper_snomasks", "$@31", "snomask_oitems", "snomask_oitem",
  "general_oper_only_umodes", "$@32", "umode_items", "umode_item",
  "general_disable_chmodes", "general_use_target_change",
  "general_min_nonwildcard", "general_min_nonwildcard_simple",
  "general_default_floodcount", "general_default_floodtime",
  "channel_entry", "channel_items", "channel_item",
  "channel_disable_fake_channels", "channel_knock_delay",
  "channel_knock_delay_channel", "channel_max_chans_per_user",
  "channel_max_bans", "channel_default_split_user_count",
  "channel_default_split_server_count", "channel_no_create_on_split",
  "channel_no_join_on_split", "channel_jflood_count",
  "channel_jflood_time", "channel_quiet_on_ban", "channel_invite_throttle",
  "serverhide_entry", "serverhide_items", "serverhide_item",
  "serverhide_flatten_links", "serverhide_disable_remote_commands",
  "serverhide_hide_servers", "serverhide_hide_services",
  "serverhide_hidden_name", "serverhide_links_delay", "serverhide_hidden",
  "serverhide_hide_server_ips", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,    59,   125,   123,
      61,    44,    58
};
# endif

#define YYPACT_NINF -865

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-865)))

#define YYTABLE_NINF -179

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -865,   725,  -865,  -240,  -259,  -253,  -865,  -865,  -865,  -865,
    -865,  -218,  -865,  -212,  -865,  -865,  -865,  -201,  -865,  -865,
    -865,  -188,  -187,  -865,  -865,  -865,  -185,  -180,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,   378,   878,  -168,
    -158,  -145,  -142,  -140,    10,  -124,   449,  -115,   -94,   -86,
     209,   -54,   -45,   -24,   623,   410,    -3,    35,    54,    18,
      23,    66,  -233,    -1,    24,    56,    76,  -865,  -865,  -865,
    -865,  -865,    70,   101,   103,   113,   115,   116,   119,   125,
     135,   136,   142,   143,   144,   152,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
     799,   610,   390,   175,   307,  -865,   145,    14,  -865,  -865,
     306,  -865,   146,   149,   151,   153,   155,   161,   162,   165,
     166,   167,   181,   182,   184,   188,   189,   190,   194,   195,
     198,   204,   211,   212,   213,   219,   222,   223,   225,   228,
     232,   233,   235,   236,   238,   249,   253,   256,   257,  -865,
     258,  -865,  -865,   259,   264,   265,   269,   274,   275,   278,
     280,   281,   283,   284,   285,   288,   290,   296,   299,   302,
     303,   304,   308,   310,   314,   315,    25,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,   563,    95,   316,    98,   326,   327,    68,  -865,
    -865,  -865,     3,   423,   300,  -865,   329,   331,   333,   334,
     335,   336,   340,   342,   242,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,   111,   343,   344,   346,   347,   350,
     352,   356,   359,   360,   361,   366,   210,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,   606,
     295,   177,   178,   367,    63,  -865,  -865,  -865,   368,  -865,
     370,    85,  -865,  -865,   147,  -865,   270,   294,   434,   381,
    -865,   515,   518,   406,   520,   522,   520,   520,   520,   523,
     524,   412,   414,   417,   399,  -865,   401,   400,   404,   407,
     411,   413,  -865,   415,   418,   420,   431,   436,   437,   438,
     442,   445,   446,   447,   454,   458,    13,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,   402,   461,   462,
     465,   466,   467,   470,    19,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,   409,   472,   479,   482,   484,   485,   487,   488,
    -865,   489,   490,   491,   494,   498,   499,   502,   176,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,   503,   508,    78,  -865,
    -865,  -865,   513,   511,   512,   516,   102,  -865,  -865,  -865,
    -865,   519,   521,  -865,  -865,   517,   525,    84,  -865,  -865,
    -865,   432,   535,   520,   520,   530,   543,   657,   663,   520,
     664,   520,   553,   650,   669,   557,   559,   560,   520,   561,
     676,   677,   520,   678,   566,   570,   571,   520,   668,   686,
     692,   520,   695,   696,   697,   698,   586,   589,   568,   591,
     573,   574,   592,   520,   520,   593,   600,   700,   601,  -235,
    -230,   602,   605,   607,   617,   702,   714,   732,   520,   622,
     738,   520,   520,   626,   628,   614,  -865,   615,   613,   619,
     620,  -865,   621,   627,   632,   633,   639,   643,    45,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,   644,   647,   108,  -865,  -865,  -865,   625,   648,   649,
    -865,   653,   656,  -865,   158,  -865,  -865,  -865,  -865,  -865,
    -865,   744,   746,   638,  -865,   661,   662,   667,    22,  -865,
    -865,  -865,   666,   670,   671,  -865,   674,   675,   680,  -865,
     681,   682,  -865,   684,    82,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,   672,   685,   689,
     694,    51,  -865,  -865,  -865,  -865,   636,   683,   690,   768,
     699,   708,   717,   520,   679,  -865,  -865,   810,   720,   817,
     835,   836,   823,   825,   826,   841,   828,   829,   719,  -865,
     722,   721,   730,  -865,   733,   734,   735,   252,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,   723,   737,   741,   742,   743,
     180,  -865,  -865,  -865,  -865,  -865,   748,   749,  -865,   109,
    -865,  -865,  -865,  -865,   739,   753,  -865,   755,   856,   760,
    -865,   763,   766,  -865,   769,    34,  -865,  -865,  -865,  -865,
     771,   774,   776,  -865,   783,   784,   786,   693,   790,   791,
     795,   797,   798,   800,   802,   806,   807,   808,  -865,  -865,
     867,   914,   520,   941,   942,   809,   943,   946,   520,   947,
     948,   520,   932,   952,   953,   520,   954,   954,   954,   830,
    -865,  -865,   938,   939,   940,   944,   845,   949,   831,  -865,
    -865,   950,  -141,   951,   955,   847,   956,   957,   834,   958,
     959,   964,   960,   961,   962,   963,   833,  -865,   965,   966,
     838,  -865,  -865,   967,   968,   969,   839,  -865,   849,  -865,
     970,   971,   857,  -865,   858,   859,   860,   861,   862,   863,
     864,   865,   866,   868,   869,   870,   871,   872,   873,   874,
     875,   876,   877,   879,   880,   881,   882,   883,   884,   885,
     886,   887,   888,   889,   890,   891,   892,   893,   894,   895,
     896,   812,   897,   724,   824,   898,   899,   900,   901,   902,
     903,   904,   905,   906,   907,   908,   909,   910,   911,   912,
     913,   915,   916,   917,   918,   919,   920,   921,   922,   923,
    -865,  -865,   982,   993,   933,   924,  1039,  1057,  1041,  1043,
    1044,  1045,   931,  -865,  1047,  1048,   934,  -865,  -865,  1050,
    1051,   935,  1069,  1054,   945,  -865,   972,   973,  -865,  -865,
    1055,  1056,   974,  -865,  -865,  1058,   975,   976,  1059,  1061,
    1062,   977,  1063,   978,   979,  1064,   981,  -865,  -865,  1065,
    1066,  1067,   983,  -865,   984,   985,   986,   987,   988,   989,
     990,   991,  -865,   992,   994,   995,   996,   997,   998,   999,
    1000,  1001,  1002,  1003,  -865,  -865,  1068,  1070,  1004,  1072,
    1073,  1075,  1005,  -865,  -865,  1076,  1012,  1077,  1078,  1007,
    -865,  -865,  1079,  1006,  1008,  -865,  1010,  -865,   237,  1011,
    -865,  -865,  1080,  1009,  1081,  1013,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,   520,   520,   520,   520,   520,   520,   520,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  1014,  1015,  1016,  1017,  1018,   -59,  1019,  1020,
    1021,  1022,  1023,  1024,  1025,  1026,  1027,  1028,    26,  1029,
    1030,  1031,  -865,  1032,  1033,  1034,  1035,  1036,  1037,  -865,
    1038,  1040,  1042,  1046,  1049,  1052,  1053,  1060,     0,  1071,
    1074,  1082,  1083,  1084,  1085,  1086,  -865,  1087,  1088,  -865,
    -865,  -246,  -865,  1089,  1090,  -865,  -865,  1091,  1092,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -222,
    -865,  -865,   937,  1093,  1094,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -217,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -208,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  1095,  1096,  1097,   641,  1100,  1101,  1102,
    1103,  1104,  1105,  -865,  1106,  1107,  -865,  1108,  1109,   305,
     980,  1110,  -865,  1111,  -865,  -865,  -865,  1112,  1113,  -865,
    1115,  1116,   531,  1117,  1118,  1119,   782,  1120,  1121,   850,
    1122,  -865,  1123,  1124,  1125,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  1126,  1127,   196,  1128,  1129,
    1130,  -865,  1131,  1132,  1133,  1134,  -865,  1135,   635,  -865,
    -865,  1136,  1137,  1138,  -865,    77,  -865,  -865,  -865,  -865,
    -865,  1139,   629,  1142,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -159,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,   954,   954,   954,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -154,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,   967,  -865,  -865,
    -865,  -865,  -865,   812,  1147,  1149,  1151,  -865,   724,  -865,
     824,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,   -73,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,   -58,  -865,  1099,  1069,  1143,  -865,  -865,
    -865,  -865,  -865,  -865,  1140,  -865,  -865,  1141,  -865,  -865,
    -865,  -865,  1144,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,    -7,  -865,  -865,
    -865,  -865,  1145,  1146,  1148,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,    57,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,    80,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  1152,  1153,  1154,  1155,
     179,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,    91,  -865,  -865,  1159,  -127,  1156,  1160,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,    97,  -865,  -865,  -865,   -59,  -865,
    -865,  -865,  -865,     0,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,   641,  -865,   305,  -865,  -865,  -865,  1158,  1162,
    1163,  -865,   531,  1164,  1165,  1166,  -865,   782,  -865,   850,
    -865,  1174,  1176,  1177,  1161,  -865,  -865,   635,  1167,  1168,
    1169,   457,  -865,  -865,   629,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  1170,  1171,
    1172,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,   117,  -865,  -865,  -865,  -865,
    -865,  -865,   457,  -865
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       2,     0,     1,     0,     0,     0,   291,   154,   472,   522,
     140,     0,   537,     0,   367,   513,   339,     0,   131,   202,
     407,     0,     0,    68,    47,   450,     0,     0,   424,     3,
       5,    24,    25,    12,     4,    26,    27,    28,     6,     7,
       9,    10,    11,    14,    15,    16,    17,    18,    19,    20,
      21,    23,    22,     8,    13,    29,    30,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   123,   124,   126,
     125,   742,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   728,   739,   730,   731,
     732,   729,   733,   734,   735,   736,   737,   738,   740,   741,
       0,     0,     0,     0,     0,   535,     0,     0,   533,   534,
       0,   613,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   704,
       0,   687,   664,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   548,   598,   601,
     602,   603,   591,   592,   593,   594,   595,   596,   590,   559,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     586,   560,   561,   597,   563,   569,   570,   564,   566,   567,
     565,   578,   579,   568,   571,   572,   573,   562,   575,   599,
     600,   587,   588,   589,   584,   585,   576,   606,   607,   608,
     609,   610,   611,   612,   577,   574,   604,   605,   582,   583,
     580,   581,     0,     0,     0,     0,     0,     0,     0,    62,
      63,    64,     0,     0,     0,   767,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   758,   759,   760,   761,   762,
     765,   763,   764,   766,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    97,    98,   108,
     101,   102,   103,    99,   107,   104,   105,   106,   100,     0,
       0,     0,     0,     0,     0,   173,   174,   175,     0,   422,
       0,     0,   420,   421,     0,   127,     0,     0,     0,     0,
     122,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   727,     0,     0,     0,     0,
       0,     0,   333,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   294,   295,   298,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     296,   297,   299,   310,   311,   312,   313,     0,     0,     0,
       0,     0,     0,     0,     0,   157,   158,   159,   160,   161,
     162,   163,     0,     0,     0,     0,     0,     0,     0,     0,
     503,     0,     0,     0,     0,     0,     0,     0,     0,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   485,   484,
     486,   490,   487,   488,   489,   528,     0,     0,     0,   525,
     526,   527,     0,     0,     0,     0,     0,   143,   144,   145,
     146,     0,     0,   532,   543,     0,     0,     0,   540,   541,
     542,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   547,     0,     0,     0,
       0,   386,     0,     0,     0,     0,     0,     0,     0,   370,
     371,   372,   373,   378,   374,   375,   376,   377,   379,   380,
     519,     0,     0,     0,   516,   517,   518,     0,     0,     0,
     341,     0,     0,   353,     0,   351,   352,   354,   355,   356,
      65,     0,     0,     0,    61,     0,     0,     0,     0,   134,
     135,   136,     0,     0,     0,   260,     0,     0,     0,   243,
       0,     0,   226,     0,     0,   205,   206,   207,   208,   212,
     213,   214,   215,   211,   209,   210,   216,     0,     0,     0,
       0,     0,   410,   411,   412,   413,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   757,   109,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    96,
       0,     0,     0,    84,     0,     0,     0,     0,    71,    72,
      73,    74,    75,    76,    77,     0,     0,     0,     0,     0,
       0,    50,    51,    52,    53,    54,     0,     0,   458,     0,
     453,   454,   455,   176,     0,     0,   172,     0,     0,     0,
     419,     0,     0,   434,     0,     0,   427,   428,   429,   430,
       0,     0,     0,   121,     0,     0,     0,    31,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   726,   314,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     293,   164,     0,     0,     0,     0,     0,     0,     0,   156,
     491,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   474,     0,     0,
       0,   524,   147,     0,     0,     0,     0,   142,     0,   531,
       0,     0,     0,   539,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     546,   381,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   369,     0,     0,     0,   515,   357,     0,
       0,     0,     0,     0,     0,   350,     0,     0,    60,   137,
       0,     0,     0,   133,   217,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   204,   414,     0,
       0,     0,     0,   409,     0,     0,     0,     0,     0,     0,
       0,     0,   756,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    95,    78,     0,     0,     0,     0,
       0,     0,     0,    70,    55,     0,     0,     0,     0,     0,
      49,   456,     0,     0,     0,   452,     0,   171,     0,     0,
     418,   431,     0,     0,     0,     0,   426,   130,   129,   128,
     749,   748,   743,    31,    31,    31,    31,    31,    31,    31,
      33,    32,   755,   752,   753,   744,   745,   747,   746,   750,
     751,   754,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    41,     0,
       0,     0,   292,     0,     0,     0,     0,     0,     0,   155,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   473,     0,     0,   523,
     153,     0,   152,     0,     0,   141,   536,     0,     0,   538,
     617,   629,   633,   649,   616,   615,   724,   725,   670,   671,
     672,   661,   720,   655,   666,   667,   628,   619,   618,   621,
     622,   620,   636,   626,   627,   637,   625,   623,   632,   631,
     630,   656,   614,   722,   723,   660,   653,   716,   709,   710,
     713,   717,   708,   718,   711,   712,   715,   719,   714,     0,
     707,   654,   703,   692,   694,   695,   697,   696,   699,   698,
     701,   700,     0,   690,   683,   676,   677,   680,   684,   675,
     685,   678,   679,   682,   686,   681,     0,   674,   650,   648,
     651,   659,   652,   668,   639,   645,   646,   643,   644,   647,
     640,   641,   642,   658,   657,   662,   663,   624,   669,   635,
     634,   721,   638,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   368,     0,     0,   514,     0,     0,     0,
     362,   358,   361,     0,   340,    66,    67,     0,     0,   132,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   230,
       0,   203,     0,     0,     0,   408,   769,   768,   774,   772,
     775,   770,   771,   773,   112,   120,   111,   118,   119,   110,
     114,   113,   117,   115,   116,     0,     0,     0,     0,     0,
       0,    69,     0,     0,     0,     0,    48,     0,     0,   451,
     177,     0,     0,     0,   189,     0,   181,   182,   184,   183,
     423,     0,     0,     0,   425,    34,    35,    36,    37,    38,
      39,    40,   327,   328,   318,   323,   324,   338,   337,     0,
     336,   332,   320,   331,   321,   319,   330,   315,   329,   317,
     316,    41,    41,    41,    43,    42,   325,   322,   326,   167,
     168,   169,   170,   166,   165,   496,   501,   502,   498,   512,
     509,   493,   510,   507,   508,     0,   506,   511,   492,   500,
     495,   497,   499,   494,   529,   530,   150,     0,   148,   149,
     544,   545,   705,     0,     0,     0,     0,   688,     0,   665,
       0,   406,   384,   385,   395,   393,   391,   397,   392,   400,
     394,   401,   396,   398,   390,   399,     0,   389,   383,   404,
     403,   402,   405,   382,   521,   520,   365,   364,   349,   346,
     348,   347,   345,     0,   344,     0,     0,     0,   366,   138,
     139,   225,   221,   282,   269,   279,   278,   267,   272,   290,
     281,   288,   271,   274,   265,   284,   287,   266,   283,   280,
     289,   275,   277,   285,   286,   273,   276,     0,   263,   218,
     220,   222,   259,   248,   250,   251,   252,   254,   255,   253,
     257,   256,     0,   246,   223,   224,   239,   232,   233,   236,
     240,   231,   241,   234,   235,   238,   242,   237,     0,   229,
     219,   417,   415,   416,    83,    82,     0,     0,     0,     0,
       0,    87,    88,    89,    90,    79,    81,    80,    56,    59,
      58,    57,   457,   462,   468,   471,   464,   470,   465,   469,
     467,   463,   466,     0,   461,   185,     0,     0,     0,     0,
     180,   432,   438,   444,   447,   449,   440,   446,   441,   445,
     443,   439,   448,   442,     0,   437,   433,   334,     0,    44,
      45,    46,   504,     0,   151,   706,   702,   691,   693,   689,
     673,   387,     0,   342,     0,   363,   360,   359,     0,     0,
       0,   261,     0,     0,     0,     0,   244,     0,   227,   230,
      91,     0,     0,     0,     0,    86,   459,     0,     0,     0,
       0,     0,   179,   435,     0,   335,   505,   388,   343,   268,
     264,   270,   262,   258,   247,   249,   245,   228,     0,     0,
       0,    85,   460,   186,   188,   187,   195,   200,   199,   194,
     197,   201,   198,   193,   196,     0,   192,   436,    93,    92,
      94,   190,     0,   191
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -865,  -865,  -865,    30,  -341,  -864,  -736,  -865,  -865,  -865,
     551,  -865,  -865,  -865,  -865,  -865,  -865,  1173,  -865,  -865,
    -865,  -865,  -865,   578,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -183,  -865,  -865,  -865,  -865,  -865,   936,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  1157,  -865,  -865,  -865,  -865,  -865,  -865,   726,
    -865,  -865,  -865,  -865,  -865,   788,  -865,  -865,  -865,  -865,
     -52,  -865,  -865,  -865,   926,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  1098,  -865,  -865,  -865,  -865,    46,  -865,
    -865,  -865,  -865,  -865,  -314,  -865,  -865,  -865,   711,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -181,  -865,  -865,  -865,  -166,  -865,  -865,  -865,  -160,  -865,
    -865,  -865,  1114,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -156,  -865,  -865,  -865,  -865,  -865,
    -151,  -865,   761,  -865,  -865,  -865,   -12,  -865,  -865,  -865,
    -865,  -865,  -865,   789,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -146,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
     718,  -865,  -865,  -865,  -865,  -865,  1150,  -865,  -865,  -865,
    -865,   645,  -865,  -865,  -865,  -865,  -865,  -172,  -865,  -865,
    -865,   665,  -865,  -865,  -865,  -865,  -164,  -865,  -865,  -865,
    1175,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -128,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,   785,  -865,  -865,  -865,  -865,  -865,   929,  -865,
    -865,  -865,  -865,  1219,  -865,  -865,  -865,  -865,  1178,  -865,
    -865,  -865,  -865,  1208,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,    37,  -865,  -865,  -865,    52,  -865,  -865,  -865,
      58,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  1300,
    -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865,  -865,  1179,  -865,  -865,  -865,  -865,
    -865,  -865,  -865,  -865
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    29,   970,   971,  1264,  1265,    30,    77,   670,
     671,   672,   673,   674,   675,    31,   268,   269,   270,   271,
      32,    76,   657,   658,   659,   660,   661,   662,   663,   664,
     928,  1420,  1421,  1422,  1423,  1424,    33,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
      34,    86,    87,    88,    89,    90,    35,    71,   588,   589,
     590,   591,    36,    63,   456,   457,   458,   459,   460,  1031,
    1032,    37,    60,   404,   405,   406,   407,   408,   409,   410,
     411,    38,   324,   325,   326,   327,   328,  1225,  1226,  1227,
    1228,  1229,  1448,  1545,  1546,    39,    72,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   894,  1408,
    1409,   615,   891,  1392,  1393,   616,   887,  1377,  1378,    40,
      59,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   725,  1249,  1250,    41,    69,   573,   871,  1343,
    1344,   574,   575,   576,  1347,  1161,  1162,   577,   578,   579,
      42,    67,   548,   549,   550,   551,   552,   553,   554,   855,
    1326,  1327,   555,   556,   557,   558,   559,    43,    73,   621,
     622,   623,   624,   625,    44,   331,   332,   333,    45,    81,
     695,   696,   697,   698,   699,   953,  1464,  1465,    46,    78,
     679,   680,   681,   682,   943,  1443,  1444,    47,    61,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,   438,
     439,   440,   758,  1285,  1286,   441,   442,   443,   444,    48,
      68,   563,   564,   565,   566,    49,    62,   448,   449,   450,
     451,    50,   127,   128,   129,    51,    65,   467,   468,   469,
     470,    52,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   511,   247,   248,   249,   250,   251,   252,
     253,  1116,  1117,   254,   510,  1102,  1103,   255,   508,  1089,
    1090,   256,   257,   258,   259,   260,   261,    53,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,    54,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     999,  1000,  1001,   708,   585,   710,   711,   712,   998,  1283,
      57,   125,  1247,   832,   356,   125,    58,   833,   834,   322,
     397,  1296,   835,   585,   329,  1297,   131,    55,    56,   132,
     357,   358,   133,   134,   335,   691,  1261,  1262,  1263,   135,
     359,   398,   399,   400,   401,  1302,   537,   136,   402,  1303,
    1307,    64,   617,   137,  1308,   138,   139,    66,   538,  1309,
     140,   141,   142,  1310,   322,   539,   143,   144,    70,   265,
     360,   361,   145,  1011,  1012,   146,   147,    82,  1221,   445,
     148,    74,    75,   592,    79,   464,   329,   149,   150,    80,
     151,   152,   153,   154,   126,  1248,   560,   540,   126,   362,
     155,   120,   593,   452,   586,   618,   156,   157,  1467,   560,
     676,   121,  1468,  1472,  1509,    83,   158,  1473,   363,   159,
     364,   365,   366,   586,   122,    84,   367,   123,   160,   124,
     368,   541,   786,   787,   594,   161,   369,   162,   792,   163,
     794,   164,   403,   165,   166,   130,   330,   801,   691,   370,
     371,   805,   619,    91,   262,   167,   810,   692,   168,   567,
     814,   998,   446,   372,   169,   170,   171,   172,   595,   173,
     174,   175,   826,   827,   176,   263,   445,   412,   676,   413,
    1416,   665,   414,   264,    92,    93,   373,   843,   266,   415,
     846,   847,   542,   374,  1481,    94,   416,  1416,  1482,    85,
    1222,   543,   544,   177,   453,   596,   620,   465,   330,  1483,
     265,   294,   587,  1484,   178,   272,   267,   179,   180,   181,
     182,   183,   184,   185,   273,   454,   545,  -178,   417,   597,
     546,   587,   677,   447,   568,    95,   375,  1284,  1221,   466,
      96,    97,   569,   275,   570,   274,   598,    98,    99,   295,
     561,   186,   418,   650,   187,   419,   100,   455,   101,   446,
    1491,   599,   420,   561,  1492,   651,   319,   600,   601,   336,
     692,   652,  -178,   421,   188,   189,   190,   323,   191,   192,
     193,   739,   462,   102,   103,   194,   276,   748,   296,   195,
     882,   693,   911,   535,   337,   694,   665,   297,   277,   422,
     677,   617,   955,   666,   320,   104,   547,   464,   452,   571,
    1223,   278,   279,   862,   280,   281,   282,   567,   667,   902,
     602,   298,   323,   321,  1496,   299,   338,   423,  1497,   266,
     447,   685,   653,   300,  1224,   334,   583,   301,   302,  1338,
     341,   283,  1417,   603,   339,  1449,   770,  1498,   424,   572,
     896,  1499,   782,   689,   618,  1418,   562,   267,  1506,  1417,
    1222,   425,  1507,  1419,  1513,   580,   678,   426,  1514,   562,
     776,   342,  1418,   343,  1339,   654,   866,   944,   636,    82,
    1419,   984,  1340,   344,  1551,   345,   346,   990,  1552,   347,
     993,   412,   568,   413,   997,   348,   414,  1469,  1470,  1471,
     569,   619,   570,   415,   693,   349,   350,   668,   694,   453,
     416,   294,   351,   352,   353,   461,   471,    83,   666,   472,
     354,   473,   700,   474,   592,   475,   874,    84,   303,   465,
     454,   476,   477,   667,   678,   478,   479,   480,   427,   655,
     656,   669,   417,   593,   766,   683,   701,  1504,   939,   295,
     131,   481,   482,   132,   483,   620,   133,   134,   484,   485,
     486,   466,   455,   135,   487,   488,   418,   571,   489,   419,
    1223,   136,   304,   305,   490,   594,   420,   137,   648,   138,
     139,   491,   492,   493,   140,   141,   142,   421,   296,   494,
     143,   144,   495,   496,  1224,   497,   145,   297,   498,   146,
     147,    85,   499,   500,   148,   501,   502,   572,   503,   595,
     634,   149,   150,   422,   151,   152,   153,   154,  1536,   504,
     932,   298,   668,   505,   155,   299,   506,   507,   509,   512,
     156,   157,  1341,   300,   513,   514,  1353,   301,   302,   515,
     158,   423,  1342,   159,   516,   517,   596,  1537,   518,  1538,
     519,   520,   160,   521,   522,   523,   669,  1354,   524,   161,
     525,   162,   424,   163,   537,   164,   526,   165,   166,   527,
     597,  1355,   528,   529,   530,   425,   538,   687,   531,   167,
     532,   426,   168,   539,   533,   534,   702,   598,   169,   170,
     171,   172,  1356,   173,   174,   175,   581,   582,   176,   626,
    1539,   627,   599,   628,   629,   630,   631,   650,   600,   601,
     632,   397,   633,   637,   638,   540,   639,   640,  1540,   651,
     641,  1357,   642,  1358,   275,   652,   643,   177,   303,   644,
     645,   646,   398,   399,   400,   401,   647,   684,   178,   402,
     688,   179,   180,   181,   182,   183,   184,   185,   703,   541,
     704,  1359,   427,   705,   706,   707,  1314,   709,   713,   714,
     715,   602,   716,  1541,  1542,   717,   718,   276,   719,   741,
     720,   778,   304,   305,   721,   186,   750,   722,   187,   277,
     784,   723,   788,   724,   603,   726,   653,  1315,   727,  1360,
     728,  1361,   278,   279,  1316,   280,   281,   282,   188,   189,
     190,   729,   191,   192,   193,  1317,   730,   731,   732,   194,
     542,  1510,   733,   195,  1362,   734,   735,   736,  1543,   543,
     544,  1452,   283,  1544,   737,     2,     3,  1433,   738,   654,
       4,   742,   743,   403,  1318,   744,   745,   746,  1363,  1364,
     747,     5,   751,  1365,   545,     6,     7,  1366,   546,   752,
    1367,     8,   753,  1368,   754,   755,  1369,   756,   757,   759,
     760,   761,  1370,     9,   762,  1319,  1320,  1321,   763,   764,
      10,  1371,   765,   768,  1372,  1322,  1373,  1374,   769,    11,
     772,   773,   774,   785,    12,    13,   775,   780,   779,  1375,
    1453,   789,   790,   655,   656,   781,  1434,  1376,   791,   793,
     356,   795,   796,  1323,   797,   798,  1454,   799,   800,   802,
      14,   803,   804,   806,   807,    15,   357,   358,   808,   809,
     811,   812,  1092,  1324,   547,    16,   359,   813,   707,  1455,
     815,   816,   817,   818,   819,  1435,  1456,   820,   821,   822,
     825,   828,  1436,   823,   824,  1457,    17,    18,   829,   831,
     836,  1437,   830,   837,   840,   838,   360,   361,   963,   964,
     965,   966,   967,   968,   969,   839,   841,   842,    19,  1458,
     844,  1459,  1460,   845,   848,  1438,   849,  1439,  1440,    91,
    1382,   850,   851,   852,   904,   362,    20,  1461,  1325,   853,
     854,   856,   868,  1441,  1462,  1463,   876,   857,   877,    21,
      22,  1442,   858,   859,   363,   878,   364,   365,   366,   860,
      92,    93,   367,   861,   864,    23,   368,   865,   869,   870,
     907,    94,   369,   872,    24,  1093,   873,  1094,   879,    25,
    1095,   905,   880,   884,  1096,   370,   371,   881,   906,   898,
     885,   886,    26,  1097,   888,   889,   912,   908,  1098,   372,
     890,   892,   893,    27,   895,   899,   909,    28,  1099,   900,
    1100,    95,   913,  1101,   901,   910,    96,    97,   914,   915,
     916,   917,   373,    98,    99,   918,   921,   919,   920,   374,
     922,   923,   100,  1383,   101,  1384,   924,   946,  1385,   925,
     934,   926,  1386,  1235,  1236,  1237,  1238,  1239,  1240,  1241,
     927,  1387,   982,   929,   930,   931,  1388,   935,   949,   102,
     103,   936,   937,   938,  1077,   941,  1389,  1078,  1390,   942,
     947,  1391,   375,  1079,   948,  1080,  1104,   950,  1081,  1105,
     951,   104,  1082,  1083,  1084,  1106,   952,  1107,   957,   954,
    1108,   958,  1085,   959,  1109,  1110,  1111,  1086,  1087,   983,
     960,   961,  1396,   962,  1112,  1397,  1088,   972,   973,  1113,
    1114,  1398,   974,  1399,   975,   976,  1400,   977,  1115,   978,
    1401,  1402,  1403,   979,   980,   981,   985,   986,   988,   987,
    1404,   989,   991,   992,   994,  1405,  1406,   995,   996,   998,
    1003,  1004,  1005,  1007,  1407,  1015,  1006,  1002,  1009,  1021,
    1026,  1008,  1010,  1013,  1018,  1029,  1035,  1014,  1016,  1017,
    1019,  1020,  1022,  1023,  1024,  1025,  1036,  1027,  1028,  1030,
    1033,  1034,  1037,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,  1046,  1047,  1048,  1143,  1049,  1050,  1051,  1052,  1053,
    1054,  1055,  1056,  1057,  1058,  1144,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,
    1073,  1074,  1075,  1076,  1091,  1118,  1119,  1120,  1121,  1122,
    1123,  1124,  1125,  1126,  1127,  1128,  1129,  1130,  1131,  1132,
    1133,  1145,  1134,  1135,  1136,  1137,  1138,  1139,  1140,  1141,
    1142,  1147,  1148,  1149,  1146,  1150,  1151,  1152,  1153,  1154,
    1155,  1156,  1157,  1158,  1160,  1159,  1163,  1167,  1168,  1304,
    1170,  1173,  1164,  1174,  1175,  1177,  1180,  1182,  1183,  1184,
    1205,   940,  1206,  1171,  1208,  1209,  1178,  1210,  1212,  1214,
    1215,  1217,  1231,  1233,  1485,   933,  1345,  1505,  1553,  1165,
    1166,  1169,   649,   340,   777,  1474,  1172,  1176,  1181,  1179,
    1185,  1186,  1187,  1188,  1189,  1190,  1191,  1192,  1193,  1194,
    1213,  1195,  1196,  1197,  1198,  1199,  1200,  1201,  1202,  1203,
    1204,  1450,  1211,  1207,  1216,  1219,  1218,  1220,  1230,  1232,
    1234,  1242,  1243,  1244,  1245,  1246,  1251,  1252,  1253,  1254,
    1255,  1256,  1257,  1258,  1259,  1260,  1266,  1267,  1268,  1269,
    1270,  1271,  1272,  1273,  1274,  1275,  1476,  1276,  1477,  1277,
    1478,  1508,  1515,  1278,   883,   897,  1279,  1519,  1527,  1280,
    1281,  1520,  1521,  1523,  1524,  1525,  1528,  1282,  1529,  1530,
     749,  1526,  1522,  1518,  1486,   875,  1517,   863,  1287,   903,
     956,  1288,  1547,  1532,   945,  1516,   463,  1480,   867,  1289,
    1290,  1291,  1292,  1293,  1294,  1295,  1298,  1299,  1300,  1301,
    1479,  1475,  1311,  1312,  1313,  1305,  1306,  1328,  1329,  1330,
    1331,  1332,  1333,  1334,  1335,  1336,  1337,   771,  1348,  1349,
    1350,  1346,  1351,  1352,  1379,  1380,  1381,  1394,  1395,  1410,
    1411,  1412,  1413,  1414,  1415,  1425,  1426,  1427,  1428,  1429,
    1430,  1431,  1432,  1445,   536,   355,  1451,  1446,  1447,  1466,
    1487,     0,  1488,  1489,     0,     0,  1490,  1493,  1494,  1500,
    1495,     0,   686,  1501,  1502,  1503,  1511,  1512,  1531,     0,
       0,     0,     0,     0,  1533,  1534,  1535,  1548,  1549,  1550,
       0,   584,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   635,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   690,     0,     0,     0,     0,     0,     0,     0,     0,
     740,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   767,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   783
};

static const yytype_int16 yycheck[] =
{
     736,   737,   738,   344,     1,   346,   347,   348,   135,     9,
     269,     1,    71,   248,     1,     1,   269,   252,   248,     1,
       1,   267,   252,     1,     1,   271,     1,   267,   268,     4,
      17,    18,     7,     8,   267,     1,    10,    11,    12,    14,
      27,    22,    23,    24,    25,   267,     1,    22,    29,   271,
     267,   269,     1,    28,   271,    30,    31,   269,    13,   267,
      35,    36,    37,   271,     1,    20,    41,    42,   269,     1,
      57,    58,    47,   214,   215,    50,    51,     1,     1,     1,
      55,   269,   269,     1,   269,     1,     1,    62,    63,   269,
      65,    66,    67,    68,    84,   154,     1,    52,    84,    86,
      75,   269,    20,     1,   101,    54,    81,    82,   267,     1,
       1,   269,   271,   267,   241,    39,    91,   271,   105,    94,
     107,   108,   109,   101,   269,    49,   113,   269,   103,   269,
     117,    86,   473,   474,    52,   110,   123,   112,   479,   114,
     481,   116,   123,   118,   119,   269,   123,   488,     1,   136,
     137,   492,   101,     1,   269,   130,   497,   123,   133,     1,
     501,   135,    84,   150,   139,   140,   141,   142,    86,   144,
     145,   146,   513,   514,   149,   269,     1,     1,     1,     3,
       1,     1,     6,   269,    32,    33,   173,   528,   120,    13,
     531,   532,   147,   180,   267,    43,    20,     1,   271,   123,
     123,   156,   157,   178,   102,   123,   155,   123,   123,   267,
       1,     1,   209,   271,   189,   269,   148,   192,   193,   194,
     195,   196,   197,   198,   269,   123,   181,   209,    52,   147,
     185,   209,   123,   155,    76,    83,   223,   237,     1,   155,
      88,    89,    84,     1,    86,   269,   164,    95,    96,    39,
     155,   226,    76,     1,   229,    79,   104,   155,   106,    84,
     267,   179,    86,   155,   271,    13,   269,   185,   186,   270,
     123,    19,   209,    97,   249,   250,   251,   259,   253,   254,
     255,   268,   268,   131,   132,   260,    44,   268,    78,   264,
     268,   257,   633,   268,   270,   261,     1,    87,    56,   123,
     123,     1,   268,   123,   269,   153,   261,     1,     1,   151,
     233,    69,    70,   268,    72,    73,    74,     1,   138,   268,
     238,   111,   259,   269,   267,   115,   270,   151,   271,   120,
     155,   268,    80,   123,   257,   269,   268,   127,   128,    34,
     270,    99,   163,   261,   268,   268,   268,   267,   172,   191,
     268,   271,   268,   268,    54,   176,   261,   148,   267,   163,
     123,   185,   271,   184,   267,   267,   257,   191,   271,   261,
     268,   270,   176,   270,    69,   123,   268,   268,   267,     1,
     184,   722,    77,   270,   267,   270,   270,   728,   271,   270,
     731,     1,    76,     3,   735,   270,     6,  1261,  1262,  1263,
      84,   101,    86,    13,   257,   270,   270,   227,   261,   102,
      20,     1,   270,   270,   270,   270,   270,    39,   123,   270,
     268,   270,   152,   270,     1,   270,   268,    49,   218,   123,
     123,   270,   270,   138,   257,   270,   270,   270,   262,   187,
     188,   261,    52,    20,   268,   267,   152,   268,   268,    39,
       1,   270,   270,     4,   270,   155,     7,     8,   270,   270,
     270,   155,   155,    14,   270,   270,    76,   151,   270,    79,
     233,    22,   262,   263,   270,    52,    86,    28,   268,    30,
      31,   270,   270,   270,    35,    36,    37,    97,    78,   270,
      41,    42,   270,   270,   257,   270,    47,    87,   270,    50,
      51,   123,   270,   270,    55,   270,   270,   191,   270,    86,
     268,    62,    63,   123,    65,    66,    67,    68,    61,   270,
     268,   111,   227,   270,    75,   115,   270,   270,   270,   270,
      81,    82,   227,   123,   270,   270,     5,   127,   128,   270,
      91,   151,   237,    94,   270,   270,   123,    90,   270,    92,
     270,   270,   103,   270,   270,   270,   261,    26,   270,   110,
     270,   112,   172,   114,     1,   116,   270,   118,   119,   270,
     147,    40,   270,   270,   270,   185,    13,   209,   270,   130,
     270,   191,   133,    20,   270,   270,   152,   164,   139,   140,
     141,   142,    61,   144,   145,   146,   270,   270,   149,   270,
     143,   270,   179,   270,   270,   270,   270,     1,   185,   186,
     270,     1,   270,   270,   270,    52,   270,   270,   161,    13,
     270,    90,   270,    92,     1,    19,   270,   178,   218,   270,
     270,   270,    22,    23,    24,    25,   270,   270,   189,    29,
     270,   192,   193,   194,   195,   196,   197,   198,   267,    86,
     135,   120,   262,   135,   248,   135,    15,   135,   135,   135,
     248,   238,   248,   206,   207,   248,   267,    44,   267,   267,
     270,   152,   262,   263,   270,   226,   267,   270,   229,    56,
     248,   270,   152,   270,   261,   270,    80,    46,   270,   158,
     270,   160,    69,    70,    53,    72,    73,    74,   249,   250,
     251,   270,   253,   254,   255,    64,   270,   270,   270,   260,
     147,  1447,   270,   264,   183,   270,   270,   270,   261,   156,
     157,    92,    99,   266,   270,     0,     1,    92,   270,   123,
       5,   270,   270,   123,    93,   270,   270,   270,   207,   208,
     270,    16,   270,   212,   181,    20,    21,   216,   185,   270,
     219,    26,   270,   222,   270,   270,   225,   270,   270,   270,
     270,   270,   231,    38,   270,   124,   125,   126,   270,   270,
      45,   240,   270,   270,   243,   134,   245,   246,   270,    54,
     267,   270,   270,   248,    59,    60,   270,   270,   267,   258,
     161,   248,   135,   187,   188,   270,   161,   266,   135,   135,
       1,   248,   152,   162,   135,   248,   177,   248,   248,   248,
      85,   135,   135,   135,   248,    90,    17,    18,   248,   248,
     152,   135,    98,   182,   261,   100,    27,   135,   135,   200,
     135,   135,   135,   135,   248,   200,   207,   248,   270,   248,
     248,   248,   207,   270,   270,   216,   121,   122,   248,   248,
     248,   216,   152,   248,   152,   248,    57,    58,   165,   166,
     167,   168,   169,   170,   171,   248,   152,   135,   143,   240,
     248,   242,   243,   135,   248,   240,   248,   242,   243,     1,
      98,   267,   267,   270,   248,    86,   161,   258,   247,   270,
     270,   270,   267,   258,   265,   266,   152,   270,   152,   174,
     175,   266,   270,   270,   105,   267,   107,   108,   109,   270,
      32,    33,   113,   270,   270,   190,   117,   270,   270,   270,
     152,    43,   123,   270,   199,   201,   270,   203,   267,   204,
     206,   248,   270,   267,   210,   136,   137,   270,   248,   267,
     270,   270,   217,   219,   270,   270,   267,   248,   224,   150,
     270,   270,   270,   228,   270,   270,   248,   232,   234,   270,
     236,    83,   152,   239,   270,   248,    88,    89,   248,   152,
     135,   135,   173,    95,    96,   152,   135,   152,   152,   180,
     152,   152,   104,   201,   106,   203,   267,   248,   206,   267,
     267,   270,   210,   963,   964,   965,   966,   967,   968,   969,
     270,   219,   135,   270,   270,   270,   224,   270,   152,   131,
     132,   270,   270,   270,   202,   267,   234,   205,   236,   270,
     267,   239,   223,   211,   269,   213,   202,   267,   216,   205,
     267,   153,   220,   221,   222,   211,   270,   213,   267,   270,
     216,   267,   230,   267,   220,   221,   222,   235,   236,   135,
     267,   267,   202,   267,   230,   205,   244,   267,   267,   235,
     236,   211,   267,   213,   267,   267,   216,   267,   244,   267,
     220,   221,   222,   267,   267,   267,   135,   135,   135,   270,
     230,   135,   135,   135,   152,   235,   236,   135,   135,   135,
     152,   152,   152,   248,   244,   248,   152,   267,   267,   135,
     267,   152,   152,   152,   270,   267,   267,   152,   152,   152,
     152,   152,   152,   152,   152,   152,   267,   152,   152,   152,
     152,   152,   152,   152,   267,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   152,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   152,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   248,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   152,   135,   152,   270,   152,   152,   152,   267,   152,
     152,   267,   152,   152,   135,   270,   152,   152,   152,   272,
     152,   152,   267,   152,   152,   152,   152,   152,   152,   152,
     152,   670,   152,   248,   152,   152,   248,   152,   152,   152,
     152,   152,   152,   152,   135,   657,   256,  1420,  1552,   267,
     267,   267,   306,    86,   456,  1297,   270,   270,   267,   270,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     248,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,  1225,   267,   269,   267,   267,   270,   267,   267,   270,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   159,   267,   159,   267,
     159,   152,  1468,   267,   588,   604,   267,   159,  1499,   267,
     267,   159,   159,   159,   159,   159,   152,   267,   152,   152,
     404,  1497,  1492,  1484,  1346,   574,  1482,   548,   267,   621,
     695,   267,  1514,  1507,   679,  1473,   127,  1310,   563,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
    1308,  1303,   267,   267,   267,   272,   272,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   448,   267,   267,
     267,   271,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   196,   105,   267,   270,   270,   267,
     267,    -1,   272,   272,    -1,    -1,   272,   272,   272,   267,
     272,    -1,   324,   270,   270,   270,   270,   267,   267,    -1,
      -1,    -1,    -1,    -1,   267,   267,   267,   267,   267,   267,
      -1,   268,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   284,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   331,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     376,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   428,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   467
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   274,     0,     1,     5,    16,    20,    21,    26,    38,
      45,    54,    59,    60,    85,    90,   100,   121,   122,   143,
     161,   174,   175,   190,   199,   204,   217,   228,   232,   275,
     280,   288,   293,   309,   323,   329,   335,   344,   354,   368,
     392,   418,   433,   450,   457,   461,   471,   480,   502,   508,
     514,   518,   524,   600,   616,   267,   268,   269,   269,   393,
     345,   481,   509,   336,   269,   519,   269,   434,   503,   419,
     269,   330,   369,   451,   269,   269,   294,   281,   472,   269,
     269,   462,     1,    39,    49,   123,   324,   325,   326,   327,
     328,     1,    32,    33,    43,    83,    88,    89,    95,    96,
     104,   106,   131,   132,   153,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     269,   269,   269,   269,   269,     1,    84,   515,   516,   517,
     269,     1,     4,     7,     8,    14,    22,    28,    30,    31,
      35,    36,    37,    41,    42,    47,    50,    51,    55,    62,
      63,    65,    66,    67,    68,    75,    81,    82,    91,    94,
     103,   110,   112,   114,   116,   118,   119,   130,   133,   139,
     140,   141,   142,   144,   145,   146,   149,   178,   189,   192,
     193,   194,   195,   196,   197,   198,   226,   229,   249,   250,
     251,   253,   254,   255,   260,   264,   525,   526,   527,   528,
     529,   530,   531,   532,   533,   534,   535,   536,   537,   538,
     539,   540,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   550,   551,   552,   553,   554,   555,   556,   557,   558,
     559,   560,   561,   562,   563,   564,   565,   566,   567,   568,
     569,   570,   571,   572,   573,   574,   575,   577,   578,   579,
     580,   581,   582,   583,   586,   590,   594,   595,   596,   597,
     598,   599,   269,   269,   269,     1,   120,   148,   289,   290,
     291,   292,   269,   269,   269,     1,    44,    56,    69,    70,
      72,    73,    74,    99,   617,   618,   619,   620,   621,   622,
     623,   624,   625,   626,     1,    39,    78,    87,   111,   115,
     123,   127,   128,   218,   262,   263,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   269,
     269,   269,     1,   259,   355,   356,   357,   358,   359,     1,
     123,   458,   459,   460,   269,   267,   270,   270,   270,   268,
     325,   270,   270,   270,   270,   270,   270,   270,   270,   270,
     270,   270,   270,   270,   268,   602,     1,    17,    18,    27,
      57,    58,    86,   105,   107,   108,   109,   113,   117,   123,
     136,   137,   150,   173,   180,   223,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     1,    22,    23,
      24,    25,    29,   123,   346,   347,   348,   349,   350,   351,
     352,   353,     1,     3,     6,    13,    20,    52,    76,    79,
      86,    97,   123,   151,   172,   185,   191,   262,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   498,   499,   500,   501,     1,    84,   155,   510,   511,
     512,   513,     1,   102,   123,   155,   337,   338,   339,   340,
     341,   270,   268,   516,     1,   123,   155,   520,   521,   522,
     523,   270,   270,   270,   270,   270,   270,   270,   270,   270,
     270,   270,   270,   270,   270,   270,   270,   270,   270,   270,
     270,   270,   270,   270,   270,   270,   270,   270,   270,   270,
     270,   270,   270,   270,   270,   270,   270,   270,   591,   270,
     587,   576,   270,   270,   270,   270,   270,   270,   270,   270,
     270,   270,   270,   270,   270,   270,   270,   270,   270,   270,
     270,   270,   270,   270,   270,   268,   526,     1,    13,    20,
      52,    86,   147,   156,   157,   181,   185,   261,   435,   436,
     437,   438,   439,   440,   441,   445,   446,   447,   448,   449,
       1,   155,   261,   504,   505,   506,   507,     1,    76,    84,
      86,   151,   191,   420,   424,   425,   426,   430,   431,   432,
     267,   270,   270,   268,   290,     1,   101,   209,   331,   332,
     333,   334,     1,    20,    52,    86,   123,   147,   164,   179,
     185,   186,   238,   261,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   384,   388,     1,    54,   101,
     155,   452,   453,   454,   455,   456,   270,   270,   270,   270,
     270,   270,   270,   270,   268,   618,   267,   270,   270,   270,
     270,   270,   270,   270,   270,   270,   270,   270,   268,   311,
       1,    13,    19,    80,   123,   187,   188,   295,   296,   297,
     298,   299,   300,   301,   302,     1,   123,   138,   227,   261,
     282,   283,   284,   285,   286,   287,     1,   123,   257,   473,
     474,   475,   476,   267,   270,   268,   356,   209,   270,   268,
     459,     1,   123,   257,   261,   463,   464,   465,   466,   467,
     152,   152,   152,   267,   135,   135,   248,   135,   277,   135,
     277,   277,   277,   135,   135,   248,   248,   248,   267,   267,
     270,   270,   270,   270,   270,   415,   270,   270,   270,   270,
     270,   270,   270,   270,   270,   270,   270,   270,   270,   268,
     395,   267,   270,   270,   270,   270,   270,   270,   268,   347,
     267,   270,   270,   270,   270,   270,   270,   270,   495,   270,
     270,   270,   270,   270,   270,   270,   268,   483,   270,   270,
     268,   511,   267,   270,   270,   270,   268,   338,   152,   267,
     270,   270,   268,   521,   248,   248,   277,   277,   152,   248,
     135,   135,   277,   135,   277,   248,   152,   135,   248,   248,
     248,   277,   248,   135,   135,   277,   135,   248,   248,   248,
     277,   152,   135,   135,   277,   135,   135,   135,   135,   248,
     248,   270,   248,   270,   270,   248,   277,   277,   248,   248,
     152,   248,   248,   252,   248,   252,   248,   248,   248,   248,
     152,   152,   135,   277,   248,   135,   277,   277,   248,   248,
     267,   267,   270,   270,   270,   442,   270,   270,   270,   270,
     270,   270,   268,   436,   270,   270,   268,   505,   267,   270,
     270,   421,   270,   270,   268,   425,   152,   152,   267,   267,
     270,   270,   268,   332,   267,   270,   270,   389,   270,   270,
     270,   385,   270,   270,   381,   270,   268,   371,   267,   270,
     270,   270,   268,   453,   248,   248,   248,   152,   248,   248,
     248,   277,   267,   152,   248,   152,   135,   135,   152,   152,
     152,   135,   152,   152,   267,   267,   270,   270,   303,   270,
     270,   270,   268,   296,   267,   270,   270,   270,   270,   268,
     283,   267,   270,   477,   268,   474,   248,   267,   269,   152,
     267,   267,   270,   468,   270,   268,   464,   267,   267,   267,
     267,   267,   267,   165,   166,   167,   168,   169,   170,   171,
     276,   277,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,   135,   135,   277,   135,   135,   270,   135,   135,
     277,   135,   135,   277,   152,   135,   135,   277,   135,   279,
     279,   279,   267,   152,   152,   152,   152,   248,   152,   267,
     152,   214,   215,   152,   152,   248,   152,   152,   270,   152,
     152,   135,   152,   152,   152,   152,   267,   152,   152,   267,
     152,   342,   343,   152,   152,   267,   267,   152,   152,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   202,   205,   211,
     213,   216,   220,   221,   222,   230,   235,   236,   244,   592,
     593,   267,    98,   201,   203,   206,   210,   219,   224,   234,
     236,   239,   588,   589,   202,   205,   211,   213,   216,   220,
     221,   222,   230,   235,   236,   244,   584,   585,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,   267,   152,   152,   248,   270,   152,   135,   152,
     152,   152,   152,   267,   152,   152,   267,   152,   152,   270,
     135,   428,   429,   152,   267,   267,   267,   152,   152,   267,
     152,   248,   270,   152,   152,   152,   270,   152,   248,   270,
     152,   267,   152,   152,   152,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   152,   152,   269,   152,   152,
     152,   267,   152,   248,   152,   152,   267,   152,   270,   267,
     267,     1,   123,   233,   257,   360,   361,   362,   363,   364,
     267,   152,   270,   152,   267,   276,   276,   276,   276,   276,
     276,   276,   267,   267,   267,   267,   267,    71,   154,   416,
     417,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,    10,    11,    12,   278,   279,   267,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     267,   267,   267,     9,   237,   496,   497,   267,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   271,   267,   267,
     267,   267,   267,   271,   272,   272,   272,   267,   271,   267,
     271,   267,   267,   267,    15,    46,    53,    64,    93,   124,
     125,   126,   134,   162,   182,   247,   443,   444,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,    34,    69,
      77,   227,   237,   422,   423,   256,   271,   427,   267,   267,
     267,   267,   267,     5,    26,    40,    61,    90,    92,   120,
     158,   160,   183,   207,   208,   212,   216,   219,   222,   225,
     231,   240,   243,   245,   246,   258,   266,   390,   391,   267,
     267,   267,    98,   201,   203,   206,   210,   219,   224,   234,
     236,   239,   386,   387,   267,   267,   202,   205,   211,   213,
     216,   220,   221,   222,   230,   235,   236,   244,   382,   383,
     267,   267,   267,   267,   267,   267,     1,   163,   176,   184,
     304,   305,   306,   307,   308,   267,   267,   267,   267,   267,
     267,   267,   267,    92,   161,   200,   207,   216,   240,   242,
     243,   258,   266,   478,   479,   267,   270,   270,   365,   268,
     361,   267,    92,   161,   177,   200,   207,   216,   240,   242,
     243,   258,   265,   266,   469,   470,   267,   267,   271,   278,
     278,   278,   267,   271,   343,   593,   159,   159,   159,   589,
     585,   267,   271,   267,   271,   135,   429,   267,   272,   272,
     272,   267,   271,   272,   272,   272,   267,   271,   267,   271,
     267,   270,   270,   270,   268,   305,   267,   271,   152,   241,
     279,   270,   267,   267,   271,   417,   497,   444,   423,   159,
     159,   159,   391,   159,   159,   159,   387,   383,   152,   152,
     152,   267,   479,   267,   267,   267,    61,    90,    92,   143,
     161,   206,   207,   261,   266,   366,   367,   470,   267,   267,
     267,   267,   271,   367
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   273,   274,   274,   275,   275,   275,   275,   275,   275,
     275,   275,   275,   275,   275,   275,   275,   275,   275,   275,
     275,   275,   275,   275,   275,   275,   275,   275,   275,   275,
     275,   276,   276,   277,   277,   277,   277,   277,   277,   277,
     277,   278,   278,   279,   279,   279,   279,   281,   280,   282,
     282,   283,   283,   283,   283,   283,   284,   285,   286,   287,
     288,   289,   289,   290,   290,   290,   291,   292,   294,   293,
     295,   295,   296,   296,   296,   296,   296,   296,   296,   297,
     298,   299,   300,   301,   303,   302,   304,   304,   305,   305,
     305,   305,   306,   307,   308,   309,   310,   310,   311,   311,
     311,   311,   311,   311,   311,   311,   311,   311,   311,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   324,   325,   325,   325,   325,   326,   327,
     328,   330,   329,   331,   331,   332,   332,   332,   333,   334,
     336,   335,   337,   337,   338,   338,   338,   338,   339,   340,
     341,   342,   342,   343,   345,   344,   346,   346,   347,   347,
     347,   347,   347,   347,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   355,   356,   356,   356,   357,   359,   358,
     360,   360,   361,   361,   361,   361,   362,   363,   363,   365,
     364,   366,   366,   367,   367,   367,   367,   367,   367,   367,
     367,   367,   369,   368,   370,   370,   371,   371,   371,   371,
     371,   371,   371,   371,   371,   371,   371,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   381,   380,   382,   382,
     383,   383,   383,   383,   383,   383,   383,   383,   383,   383,
     383,   383,   383,   385,   384,   386,   386,   387,   387,   387,
     387,   387,   387,   387,   387,   387,   387,   387,   387,   387,
     389,   388,   390,   390,   391,   391,   391,   391,   391,   391,
     391,   391,   391,   391,   391,   391,   391,   391,   391,   391,
     391,   391,   391,   391,   391,   391,   391,   391,   391,   391,
     391,   393,   392,   394,   394,   395,   395,   395,   395,   395,
     395,   395,   395,   395,   395,   395,   395,   395,   395,   395,
     395,   395,   395,   395,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   415,   414,   416,   416,   417,   417,   419,
     418,   421,   420,   422,   422,   423,   423,   423,   423,   423,
     424,   424,   425,   425,   425,   425,   425,   425,   427,   426,
     428,   428,   429,   429,   430,   431,   432,   434,   433,   435,
     435,   436,   436,   436,   436,   436,   436,   436,   436,   436,
     436,   436,   437,   438,   439,   440,   442,   441,   443,   443,
     444,   444,   444,   444,   444,   444,   444,   444,   444,   444,
     444,   444,   445,   446,   447,   448,   449,   451,   450,   452,
     452,   453,   453,   453,   453,   454,   455,   456,   457,   458,
     458,   459,   459,   460,   462,   461,   463,   463,   464,   464,
     464,   464,   465,   466,   468,   467,   469,   469,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     472,   471,   473,   473,   474,   474,   474,   475,   477,   476,
     478,   478,   479,   479,   479,   479,   479,   479,   479,   479,
     479,   479,   481,   480,   482,   482,   483,   483,   483,   483,
     483,   483,   483,   483,   483,   483,   483,   483,   483,   483,
     483,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   493,   495,   494,   496,   496,   497,   497,   498,
     499,   500,   501,   503,   502,   504,   504,   505,   505,   505,
     506,   507,   509,   508,   510,   510,   511,   511,   511,   512,
     513,   514,   515,   515,   516,   516,   517,   519,   518,   520,
     520,   521,   521,   521,   522,   523,   524,   525,   525,   526,
     526,   526,   526,   526,   526,   526,   526,   526,   526,   526,
     526,   526,   526,   526,   526,   526,   526,   526,   526,   526,
     526,   526,   526,   526,   526,   526,   526,   526,   526,   526,
     526,   526,   526,   526,   526,   526,   526,   526,   526,   526,
     526,   526,   526,   526,   526,   526,   526,   526,   526,   526,
     526,   526,   526,   526,   526,   526,   526,   526,   526,   526,
     526,   526,   526,   526,   527,   528,   529,   530,   531,   532,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   556,   557,   557,   558,   559,   560,
     561,   562,   563,   564,   565,   566,   567,   568,   569,   570,
     571,   572,   573,   574,   576,   575,   577,   578,   579,   580,
     581,   582,   583,   584,   584,   585,   585,   585,   585,   585,
     585,   585,   585,   585,   585,   585,   585,   587,   586,   588,
     588,   589,   589,   589,   589,   589,   589,   589,   589,   589,
     589,   589,   589,   589,   591,   590,   592,   592,   593,   593,
     593,   593,   593,   593,   593,   593,   593,   593,   593,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   601,   602,
     602,   602,   602,   602,   602,   602,   602,   602,   602,   602,
     602,   602,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   613,   614,   615,   616,   617,   617,   618,
     618,   618,   618,   618,   618,   618,   618,   618,   619,   620,
     621,   622,   623,   624,   625,   626
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     0,     1,     2,     3,     3,     3,     3,     3,     3,
       3,     0,     1,     2,     3,     3,     3,     0,     6,     2,
       1,     1,     1,     1,     1,     2,     4,     4,     4,     4,
       5,     2,     1,     1,     1,     2,     4,     4,     0,     6,
       2,     1,     1,     1,     1,     1,     1,     1,     2,     4,
       4,     4,     4,     4,     0,     6,     2,     1,     1,     1,
       1,     2,     4,     4,     4,     5,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     5,     2,     1,     1,     1,     1,     2,     4,     4,
       4,     0,     6,     2,     1,     1,     1,     2,     4,     4,
       0,     6,     2,     1,     1,     1,     1,     2,     4,     4,
       4,     3,     1,     1,     0,     6,     2,     1,     1,     1,
       1,     1,     1,     1,     2,     4,     4,     4,     4,     4,
       4,     5,     2,     1,     1,     1,     2,     4,     0,     6,
       2,     1,     1,     1,     1,     2,     4,     4,     4,     0,
       5,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     6,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     4,     4,
       4,     4,     4,     4,     4,     4,     0,     5,     3,     1,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     5,     3,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       0,     5,     3,     1,     3,     1,     1,     1,     3,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     6,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     0,     5,     3,     1,     1,     1,     0,
       6,     0,     5,     3,     1,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     1,     2,     0,     5,
       3,     1,     1,     3,     4,     4,     4,     0,     6,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     4,     4,     4,     4,     0,     5,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     4,     4,     4,     4,     0,     6,     2,
       1,     1,     1,     1,     2,     4,     4,     4,     5,     2,
       1,     1,     1,     4,     0,     6,     2,     1,     1,     1,
       1,     2,     4,     4,     0,     5,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     6,     2,     1,     1,     1,     2,     4,     0,     5,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     6,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     0,     5,     3,     1,     1,     1,     4,
       4,     4,     4,     0,     6,     2,     1,     1,     1,     1,
       4,     4,     0,     6,     2,     1,     1,     1,     1,     4,
       4,     5,     2,     1,     1,     1,     4,     0,     6,     2,
       1,     1,     1,     1,     4,     4,     5,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     0,     5,     4,     4,     4,     4,
       4,     4,     4,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     5,     3,
       1,     3,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     0,     5,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     4,     4,     4,     4,     4,     5,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     5,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     4,
       4,     4,     4,     4,     4,     4
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 31:
#line 463 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = 0; }
#line 3175 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 33:
#line 465 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-1].number) + (yyvsp[0].number);
		}
#line 3183 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 34:
#line 469 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) + (yyvsp[0].number);
		}
#line 3191 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 35:
#line 473 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) * 60 + (yyvsp[0].number);
		}
#line 3199 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 36:
#line 477 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) * 60 * 60 + (yyvsp[0].number);
		}
#line 3207 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 37:
#line 481 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) * 60 * 60 * 24 + (yyvsp[0].number);
		}
#line 3215 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 38:
#line 485 "conf_parser.y" /* yacc.c:1646  */
    {
			(yyval.number) = (yyvsp[-2].number) * 60 * 60 * 24 * 7 + (yyvsp[0].number);
		}
#line 3223 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 39:
#line 489 "conf_parser.y" /* yacc.c:1646  */
    {
                        (yyval.number) = (yyvsp[-2].number) * 60 * 60 * 24 * 7 * 4 + (yyvsp[0].number);
                }
#line 3231 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 40:
#line 493 "conf_parser.y" /* yacc.c:1646  */
    {
                        (yyval.number) = (yyvsp[-2].number) * 60 * 60 * 24 * 365 + (yyvsp[0].number);
                }
#line 3239 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 41:
#line 498 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = 0; }
#line 3245 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 43:
#line 499 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-1].number) + (yyvsp[0].number); }
#line 3251 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 44:
#line 500 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) + (yyvsp[0].number); }
#line 3257 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 45:
#line 501 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) * 1024 + (yyvsp[0].number); }
#line 3263 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 46:
#line 502 "conf_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) * 1024 * 1024 + (yyvsp[0].number); }
#line 3269 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 47:
#line 509 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  block_state.ptr.alias = MyMalloc(sizeof(struct alias_entry));
}
#line 3280 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 48:
#line 515 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  dlinkAdd(block_state.ptr.alias, &block_state.ptr.alias->node, &alias_items);
  alias_add(block_state.ptr.alias);
}
#line 3292 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 56:
#line 527 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  struct alias_name *nm = MyMalloc(sizeof(struct alias_name));

  strlcpy(nm->name, yylval.string, sizeof(nm->name));
  nm->parent = block_state.ptr.alias;

  dlinkAdd(nm, &nm->node, &block_state.ptr.alias->names);
}
#line 3308 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 57:
#line 540 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.ptr.alias->user, yylval.string, sizeof(block_state.ptr.alias->user));
}
#line 3317 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 58:
#line 546 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.ptr.alias->server, yylval.string, sizeof(block_state.ptr.alias->server));
}
#line 3326 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 59:
#line 552 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (yylval.number)
      block_state.ptr.alias->flags |= CONF_FLAGS_OPER_ONLY;
  }
}
#line 3338 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 66:
#line 570 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    add_conf_module(libio_basename(yylval.string));
}
#line 3347 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 67:
#line 576 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    mod_add_path(yylval.string);
}
#line 3356 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 68:
#line 583 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  block_state.ptr.ssl = sslprofile_create();
}
#line 3367 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 69:
#line 590 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *profile = block_state.ptr.ssl;
  dlink_node *ptr;

  if (conf_parser_ctx.pass != 1)
    break;

  DLINK_FOREACH(ptr, profile->identities.head)
  {
    struct sslprofile_identity *id = ptr->data;

    if (profile->dh)
      SSL_CTX_set_tmp_dh(id->server_ctx, profile->dh);

#if OPENSSL_VERSION_NUMBER >= 0x009080FFL && !defined(OPENSSL_NO_ECDH)
    if (profile->curve)
      SSL_CTX_set_tmp_ecdh(id->server_ctx, profile->curve);
#endif

    if (!EmptyString(profile->cipher_list))
    {
      SSL_CTX_set_cipher_list(id->server_ctx, profile->cipher_list);

      SSL_CTX_set_cipher_list(id->client_ctx, profile->cipher_list);
    }

    if (!EmptyString(profile->ca_file))
    {
      if (!SSL_CTX_load_verify_locations(id->server_ctx, profile->ca_file, NULL))
      {
        const char *s = ERR_lib_error_string(ERR_get_error());

        ilog(LOG_TYPE_IRCD, "Could not load verify location %s -- %s", profile->ca_file, s);
      }
    }
  }

  dlinkAddTail(block_state.ptr.ssl, &block_state.ptr.ssl->node, &sslprofile_items);
  block_state.ptr.ssl = NULL;
}
#line 3412 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 79:
#line 638 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *entry = block_state.ptr.ssl;

  if (conf_parser_ctx.pass == 1)
    strlcpy(entry->name, yylval.string, sizeof(entry->name));
}
#line 3423 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 80:
#line 646 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *entry = block_state.ptr.ssl;

  if (conf_parser_ctx.pass == 1)
  {
    BIO *file = BIO_new_file(yylval.string, "r");

    if (file)
    {
      DH *dh = PEM_read_bio_DHparams(file, NULL, NULL, NULL);

      BIO_free(file);

      if (dh)
      {
        if (DH_size(dh) < 256)
        {
          conf_error_report("Ignoring sslprofile::dh_param_file -- need at least a 2048 bit DH prime size");
          DH_free(dh);
        }
        else
        {
          entry->dh = dh;
        }
      }
    }
    else
      conf_error_report("Ignoring sslprofile::dh_param_file -- could not open/read Diffie-Hellman parameter file");
  }
}
#line 3458 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 81:
#line 678 "conf_parser.y" /* yacc.c:1646  */
    {
#if OPENSSL_VERSION_NUMBER >= 0x009080FFL && !defined(OPENSSL_NO_ECDH)
  struct sslprofile *entry = block_state.ptr.ssl;
  int nid = 0;
  EC_KEY *key = NULL;

  if (conf_parser_ctx.pass == 1)
  {
    if ((nid = OBJ_sn2nid(yylval.string)) == 0)
    {
        conf_error_report("Ignoring sslprofile::dh_elliptic_curve -- unknown curve name");
        break;
    }

    if ((key = EC_KEY_new_by_curve_name(nid)) == NULL)
    {
      conf_error_report("Ignoring sslprofile::dh_elliptic_curve -- could not create curve");
      break;
    }

    entry->curve = key;
  }
#endif
}
#line 3487 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 82:
#line 704 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *entry = block_state.ptr.ssl;

  if (conf_parser_ctx.pass == 1)
    strlcpy(entry->cipher_list, yylval.string, sizeof(entry->cipher_list));
}
#line 3498 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 83:
#line 712 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *entry = block_state.ptr.ssl;

  if (conf_parser_ctx.pass == 1)
    strlcpy(entry->ca_file, yylval.string, sizeof(entry->ca_file));
}
#line 3509 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 84:
#line 720 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  block_state.ptr.identity = sslprofile_identity_create(block_state.ptr.ssl);
}
#line 3520 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 85:
#line 727 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile *profile = block_state.ptr.ssl;
  struct sslprofile_identity *id = block_state.ptr.identity;

  if (conf_parser_ctx.pass != 1)
    break;

  if (id == NULL)
    break;

  dlinkAddTail(id, &id->node, &profile->identities);
  block_state.ptr.identity = NULL;
}
#line 3538 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 92:
#line 747 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile_identity *entry = block_state.ptr.identity;
  char *str;

  if (conf_parser_ctx.pass != 1)
    break;

  if (entry == NULL)
    break;

  str = xstrdup(yylval.string);
  dlinkAdd(str, make_dlink_node(), &entry->server_names);
}
#line 3556 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 93:
#line 762 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile_identity *entry = block_state.ptr.identity;
  BIO *file = NULL;

  if (conf_parser_ctx.pass != 1)
    break;

  if (entry == NULL)
    break;

  if (entry->rsa_private_key)
  {
    RSA_free(entry->rsa_private_key);
    entry->rsa_private_key = NULL;
  }

  if (entry->rsa_private_key_file)
  {
    MyFree(entry->rsa_private_key_file);
    entry->rsa_private_key_file = NULL;
  }

  entry->rsa_private_key_file = xstrdup(yylval.string);

  if ((file = BIO_new_file(yylval.string, "r")) == NULL)
  {
    conf_error_report("File open failed, ignoring");
    break;
  }

  entry->rsa_private_key = PEM_read_bio_RSAPrivateKey(file, NULL, 0, NULL);

  BIO_set_close(file, BIO_CLOSE);
  BIO_free(file);

  if (entry->rsa_private_key == NULL)
  {
    conf_error_report("Couldn't extract key, ignoring");
    break;
  }

  if (!RSA_check_key(entry->rsa_private_key))
  {
    RSA_free(entry->rsa_private_key);
    entry->rsa_private_key = NULL;

    conf_error_report("Invalid key, ignoring");
    break;
  }

  if (RSA_size(entry->rsa_private_key) < 256)
  {
    RSA_free(entry->rsa_private_key);
    entry->rsa_private_key = NULL;

    conf_error_report("Ignoring sslprofile::identity::rsa_private_key_file -- need at least a 2048 bit key size");
  }
}
#line 3619 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 94:
#line 822 "conf_parser.y" /* yacc.c:1646  */
    {
  struct sslprofile_identity *entry = block_state.ptr.identity;

  if (conf_parser_ctx.pass == 1 && entry)
  {
    if (!entry->rsa_private_key_file)
    {
      conf_error_report("No rsa_private_key_file specified, SSL disabled");
      break;
    }

    if (SSL_CTX_use_certificate_chain_file(entry->server_ctx, yylval.string) <= 0 ||
        SSL_CTX_use_certificate_chain_file(entry->client_ctx, yylval.string) <= 0)
    {
      report_crypto_errors();
      conf_error_report("Could not open/read certificate file");
      break;
    }

    if (SSL_CTX_use_PrivateKey_file(entry->server_ctx, entry->rsa_private_key_file,
                                    SSL_FILETYPE_PEM) <= 0 ||
        SSL_CTX_use_PrivateKey_file(entry->client_ctx, entry->rsa_private_key_file,
                                    SSL_FILETYPE_PEM) <= 0)
    {
      report_crypto_errors();
      conf_error_report("Could not read RSA private key");
      break;
    }

    if (!SSL_CTX_check_private_key(entry->server_ctx) ||
        !SSL_CTX_check_private_key(entry->client_ctx))
    {
      report_crypto_errors();
      conf_error_report("Could not read RSA private key");
      break;
    }
  }
}
#line 3662 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 110:
#line 876 "conf_parser.y" /* yacc.c:1646  */
    {
  /* this isn't rehashable */
  if (conf_parser_ctx.pass == 2 && !ServerInfo.name)
  {
    if (valid_servname(yylval.string))
      ServerInfo.name = xstrdup(yylval.string);
    else
    {
      conf_error_report("Ignoring serverinfo::name -- invalid name. Aborting.");
      exit(0);
    }
  }
}
#line 3680 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 111:
#line 891 "conf_parser.y" /* yacc.c:1646  */
    {
  /* this isn't rehashable */
  if (conf_parser_ctx.pass == 2 && !ServerInfo.sid)
  {
    if (valid_sid(yylval.string))
      ServerInfo.sid = xstrdup(yylval.string);
    else
    {
      conf_error_report("Ignoring serverinfo::sid -- invalid SID. Aborting.");
      exit(0);
    }
  }
}
#line 3698 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 112:
#line 906 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ServerInfo.description);
    ServerInfo.description = xstrdup(yylval.string);
  }
}
#line 3710 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 113:
#line 915 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    char *p;

    if ((p = strchr(yylval.string, ' ')) != NULL)
      *p = '\0';

    MyFree(ServerInfo.network_name);
    ServerInfo.network_name = xstrdup(yylval.string);
  }
}
#line 3727 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 114:
#line 929 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  MyFree(ServerInfo.network_desc);
  ServerInfo.network_desc = xstrdup(yylval.string);
}
#line 3739 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 115:
#line 938 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2 && *yylval.string != '*')
  {
    struct addrinfo hints, *res;

    memset(&hints, 0, sizeof(hints));

    hints.ai_family   = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags    = AI_PASSIVE | AI_NUMERICHOST;

    if (getaddrinfo(yylval.string, NULL, &hints, &res))
      ilog(LOG_TYPE_IRCD, "Invalid netmask for server vhost(%s)", yylval.string);
    else
    {
      assert(res != NULL);

      memcpy(&ServerInfo.ip, res->ai_addr, res->ai_addrlen);
      ServerInfo.ip.ss.ss_family = res->ai_family;
      ServerInfo.ip.ss_len = res->ai_addrlen;
      freeaddrinfo(res);

      ServerInfo.specific_ipv4_vhost = 1;
    }
  }
}
#line 3770 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 116:
#line 966 "conf_parser.y" /* yacc.c:1646  */
    {
#ifdef IPV6
  if (conf_parser_ctx.pass == 2 && *yylval.string != '*')
  {
    struct addrinfo hints, *res;

    memset(&hints, 0, sizeof(hints));

    hints.ai_family   = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags    = AI_PASSIVE | AI_NUMERICHOST;

    if (getaddrinfo(yylval.string, NULL, &hints, &res))
      ilog(LOG_TYPE_IRCD, "Invalid netmask for server vhost6(%s)", yylval.string);
    else
    {
      assert(res != NULL);

      memcpy(&ServerInfo.ip6, res->ai_addr, res->ai_addrlen);
      ServerInfo.ip6.ss.ss_family = res->ai_family;
      ServerInfo.ip6.ss_len = res->ai_addrlen;
      freeaddrinfo(res);

      ServerInfo.specific_ipv6_vhost = 1;
    }
  }
#endif
}
#line 3803 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 117:
#line 996 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].number) < MAXCLIENTS_MIN)
  {
    char buf[IRCD_BUFSIZE];

    snprintf(buf, sizeof(buf), "MAXCLIENTS too low, setting to %d", MAXCLIENTS_MIN);
    conf_error_report(buf);
    ServerInfo.max_clients = MAXCLIENTS_MIN;
  }
  else if ((yyvsp[-1].number) > MAXCLIENTS_MAX)
  {
    char buf[IRCD_BUFSIZE];

    snprintf(buf, sizeof(buf), "MAXCLIENTS too high, setting to %d", MAXCLIENTS_MAX);
    conf_error_report(buf);
    ServerInfo.max_clients = MAXCLIENTS_MAX;
  }
  else
    ServerInfo.max_clients = (yyvsp[-1].number);
}
#line 3831 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1021 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].number) < 9)
  {
    conf_error_report("max_nick_length too low, setting to 9");
    ServerInfo.max_nick_length = 9;
  }
  else if ((yyvsp[-1].number) > NICKLEN)
  {
    char buf[IRCD_BUFSIZE];

    snprintf(buf, sizeof(buf), "max_nick_length too high, setting to %d", NICKLEN);
    conf_error_report(buf);
    ServerInfo.max_nick_length = NICKLEN;
  }
  else
    ServerInfo.max_nick_length = (yyvsp[-1].number);
}
#line 3856 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1043 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].number) < 80)
  {
    conf_error_report("max_topic_length too low, setting to 80");
    ServerInfo.max_topic_length = 80;
  }
  else if ((yyvsp[-1].number) > TOPICLEN)
  {
    char buf[IRCD_BUFSIZE];

    snprintf(buf, sizeof(buf), "max_topic_length too high, setting to %d", TOPICLEN);
    conf_error_report(buf);
    ServerInfo.max_topic_length = TOPICLEN;
  }
  else
    ServerInfo.max_topic_length = (yyvsp[-1].number);
}
#line 3881 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1065 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ServerInfo.hub = yylval.number;
}
#line 3890 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1080 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  MyFree(AdminInfo.name);
  AdminInfo.name = xstrdup(yylval.string);
}
#line 3902 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1089 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  MyFree(AdminInfo.email);
  AdminInfo.email = xstrdup(yylval.string);
}
#line 3914 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1098 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  MyFree(AdminInfo.description);
  AdminInfo.description = xstrdup(yylval.string);
}
#line 3926 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1110 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 3935 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1114 "conf_parser.y" /* yacc.c:1646  */
    {
  dlink_node *ptr = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.file.buf[0])
    break;

  DLINK_FOREACH(ptr, block_state.mask.list.head)
    motd_add(ptr->data, block_state.file.buf);
}
#line 3952 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1131 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.mask.list);
}
#line 3961 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1137 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.file.buf, yylval.string, sizeof(block_state.file.buf));
}
#line 3970 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1147 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    reset_block_state();
    block_state.ptr.dnsbl = MyMalloc(sizeof(struct dnsbl_entry));
  }
}
#line 3982 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1155 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct dnsbl_entry *dnsbl = block_state.ptr.dnsbl;

    if (dlink_list_length(&dnsbl->matches) == 0)
    {
      /* Add a default match */
      struct dnsbl_match *match = MyMalloc(sizeof(struct dnsbl_match));
      parse_netmask("127.0.0.0/8", &match->ip, &match->bits);
      dlinkAdd(match, &match->node, &dnsbl->matches);
    }

    dlinkAdd(dnsbl, &dnsbl->node, &dnsbl_items);
  }
}
#line 4003 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1177 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    strlcpy(block_state.ptr.dnsbl->name, yylval.string, sizeof(block_state.ptr.dnsbl->name));
}
#line 4012 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1183 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    strlcpy(block_state.ptr.dnsbl->reason, yylval.string, sizeof(block_state.ptr.dnsbl->reason));
}
#line 4021 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1191 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct dnsbl_match *match = MyMalloc(sizeof(struct dnsbl_match));

    if (parse_netmask((yyvsp[0].string), &match->ip, &match->bits) == HM_IPV4)
    {
      dlinkAdd(match, &match->node, &block_state.ptr.dnsbl->matches);
    }
    else
    {
      char buf[IRCD_BUFSIZE];

      snprintf(buf, sizeof(buf), "dnsbl match %s not an IPv4 mask, ignored", (yyvsp[0].string));
      conf_error_report(buf);

      MyFree(match);
    }
  }
}
#line 4046 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1217 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  reset_block_state();
  block_state.ptr.cloak = MyMalloc(sizeof(struct cloak_config));
}
#line 4058 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1225 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  struct cloak_config *cloak = block_state.ptr.cloak;
  dlinkAdd(cloak, &cloak->node, &cloak_items);
}
#line 4070 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1243 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    strlcpy(block_state.ptr.cloak->name, yylval.string, sizeof(block_state.ptr.cloak->name));
}
#line 4079 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1249 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.ptr.cloak->default_cloak = yylval.number;
}
#line 4088 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1255 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct cloak_config *cloak = block_state.ptr.cloak;

    MyFree(cloak->cloak_key);
    cloak->cloak_key = xstrdup(yylval.string);
  }
}
#line 4102 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1266 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct cloak_config *cloak = block_state.ptr.cloak;

    MyFree(cloak->cloak_key1);
    cloak->cloak_key1 = xstrdup(yylval.string);
  }
}
#line 4116 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1277 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct cloak_config *cloak = block_state.ptr.cloak;

    MyFree(cloak->cloak_key2);
    cloak->cloak_key2 = xstrdup(yylval.string);
  }
}
#line 4130 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1288 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
  {
    struct cloak_config *cloak = block_state.ptr.cloak;

    MyFree(cloak->cloak_key3);
    cloak->cloak_key3 = xstrdup(yylval.string);
  }
}
#line 4144 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1308 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigLoggingEntry.use_logging = yylval.number;
}
#line 4153 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1314 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 4162 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1318 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (block_state.type.value && block_state.file.buf[0])
    log_set_file(block_state.type.value, block_state.size.value,
                 block_state.file.buf);
}
#line 4175 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1334 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  strlcpy(block_state.file.buf, yylval.string, sizeof(block_state.file.buf));
}
#line 4186 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1342 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.size.value = (yyvsp[-1].number);
}
#line 4194 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1345 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.size.value = 0;
}
#line 4202 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1350 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = 0;
}
#line 4211 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1357 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_USER;
}
#line 4220 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1361 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_OPER;
}
#line 4229 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1365 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_GLINE;
}
#line 4238 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1369 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_XLINE;
}
#line 4247 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1373 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_RESV;
}
#line 4256 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1377 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_DLINE;
}
#line 4265 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1381 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_KLINE;
}
#line 4274 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1385 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_KILL;
}
#line 4283 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1389 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.type.value = LOG_TYPE_DEBUG;
}
#line 4292 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1399 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();
  block_state.flags.value |= CONF_FLAGS_ENCRYPTED;
}
#line 4304 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1406 "conf_parser.y" /* yacc.c:1646  */
    {
  dlink_node *ptr = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.name.buf[0])
    break;
  if (!block_state.file.buf[0] &&
      !block_state.rpass.buf[0])
    break;

  DLINK_FOREACH(ptr, block_state.mask.list.head)
  {
    struct MaskItem *conf = NULL;
    struct split_nuh_item nuh;

    nuh.nuhmask  = ptr->data;
    nuh.nickptr  = NULL;
    nuh.userptr  = block_state.user.buf;
    nuh.hostptr  = block_state.host.buf;
    nuh.nicksize = 0;
    nuh.usersize = sizeof(block_state.user.buf);
    nuh.hostsize = sizeof(block_state.host.buf);
    split_nuh(&nuh);

    conf         = conf_make(CONF_OPER);
    conf->name   = xstrdup(block_state.name.buf);
    conf->user   = xstrdup(block_state.user.buf);
    conf->host   = xstrdup(block_state.host.buf);

    if (block_state.cert.buf[0])
      conf->certfp = xstrdup(block_state.cert.buf);

    if (block_state.rpass.buf[0])
      conf->passwd = xstrdup(block_state.rpass.buf);

    conf->flags = block_state.flags.value;
    conf->modes = block_state.modes.value;
    conf->snomask.local = block_state.snomask_local.value;
    conf->snomask.remote = block_state.snomask_remote.value;
    conf->port  = block_state.port.value;
    conf->htype = parse_netmask(conf->host, &conf->addr, &conf->bits);

    conf_add_class_to_conf(conf, block_state.class.buf);

    if (block_state.file.buf[0])
    {
      BIO *file = NULL;
      RSA *pkey = NULL;

      if ((file = BIO_new_file(block_state.file.buf, "r")) == NULL)
      {
        ilog(LOG_TYPE_IRCD, "Ignoring rsa_public_key_file -- file doesn't exist");
        break;
      }

      if ((pkey = PEM_read_bio_RSA_PUBKEY(file, NULL, 0, NULL)) == NULL)
        ilog(LOG_TYPE_IRCD, "Ignoring rsa_public_key_file -- Key invalid; check key syntax");
      else
      {
        if (RSA_size(pkey) > 128)
          ilog(LOG_TYPE_IRCD, "Ignoring rsa_public_key_file -- key size must be 1024 or below");
        else
          conf->rsa_public_key = pkey;
      }

      BIO_set_close(file, BIO_CLOSE);
      BIO_free(file);
    }
  }
}
#line 4381 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1487 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 4390 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1493 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.mask.list);
}
#line 4399 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1499 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 4408 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1505 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (yylval.number)
    block_state.flags.value |= CONF_FLAGS_ENCRYPTED;
  else
    block_state.flags.value &= ~CONF_FLAGS_ENCRYPTED;
}
#line 4422 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1516 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.file.buf, yylval.string, sizeof(block_state.file.buf));
}
#line 4431 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1522 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.cert.buf, yylval.string, sizeof(block_state.cert.buf));
}
#line 4440 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1528 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (yylval.number)
    block_state.flags.value |= CONF_FLAGS_SSL;
  else
    block_state.flags.value &= ~CONF_FLAGS_SSL;
}
#line 4454 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1539 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.class.buf, yylval.string, sizeof(block_state.class.buf));
}
#line 4463 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1545 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value = 0;
}
#line 4472 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1553 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
      block_state.modes.value |= UMODE_NOCTCP;
}
#line 4481 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1558 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_DEAF;
}
#line 4490 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1563 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
      block_state.modes.value |= UMODE_HIDECHANNELS;
}
#line 4499 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1568 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_OPERWALL;
}
#line 4508 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1573 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_SERVNOTICE;
}
#line 4517 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1578 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_INVISIBLE;
}
#line 4526 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1583 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_WALLOP;
}
#line 4535 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1588 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_SOFTCALLERID;
}
#line 4544 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1593 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_CALLERID;
}
#line 4553 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1598 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_LOCOPS;
}
#line 4562 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1603 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_REGONLY;
}
#line 4571 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1608 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.modes.value |= UMODE_SPY;
}
#line 4580 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1614 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value = block_state.snomask_remote.value = 0;
}
#line 4589 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1622 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_remote.value |= sno_bots.flag;
}
#line 4598 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1627 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_bots.flag;
}
#line 4607 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1632 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_remote.value |= sno_cconn.flag;
}
#line 4616 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1637 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_cconn.flag;
}
#line 4625 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1642 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_debug.flag;
}
#line 4634 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1647 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_full.flag;
}
#line 4643 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1652 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_skill.flag;
}
#line 4652 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1657 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_nchange.flag;
}
#line 4661 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1662 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_rej.flag;
}
#line 4670 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1667 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_unauth.flag;
}
#line 4679 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1672 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_local.value |= sno_spy.flag;
}
#line 4688 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1677 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.snomask_remote.value |= sno_link.flag;
}
#line 4697 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1682 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
     block_state.snomask_local.value |= sno_link.flag;
}
#line 4706 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1688 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value = 0;
}
#line 4715 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1695 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_KILL_REMOTE;
}
#line 4724 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1699 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_FARCONNECT;
}
#line 4733 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1703 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_N;
}
#line 4742 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1707 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_KILL;
}
#line 4751 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1711 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_CONNECT_REMOTE;
}
#line 4760 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1715 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_CONNECT;
}
#line 4769 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1719 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_SQUIT_REMOTE;
}
#line 4778 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1723 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_SQUIT;
}
#line 4787 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1727 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_K;
}
#line 4796 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1731 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_UNKLINE;
}
#line 4805 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1735 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_DLINE;
}
#line 4814 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1739 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_UNDLINE;
}
#line 4823 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1743 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_XLINE;
}
#line 4832 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1747 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_UNXLINE;
}
#line 4841 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1751 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_GLINE;
}
#line 4850 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1755 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_DIE;
}
#line 4859 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1759 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_RESTART;
}
#line 4868 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1763 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_REHASH;
}
#line 4877 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1767 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_ADMIN;
}
#line 4886 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1771 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_OPERWALL;
}
#line 4895 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1775 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_GLOBOPS;
}
#line 4904 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1779 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_WALLOPS;
}
#line 4913 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1783 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_WALLUSERS;
}
#line 4922 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1787 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_LOCOPS;
}
#line 4931 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1791 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_REMOTEBAN;
}
#line 4940 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1795 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_SET;
}
#line 4949 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1799 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value |= OPER_FLAG_MODULE;
}
#line 4958 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1809 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  reset_block_state();

  block_state.ping_freq.value = DEFAULT_PINGFREQUENCY;
  block_state.con_freq.value  = DEFAULT_CONNECTFREQUENCY;
  block_state.max_total.value = MAXIMUM_LINKS_DEFAULT;
  block_state.max_sendq.value = DEFAULT_SENDQ;
  block_state.max_recvq.value = DEFAULT_RECVQ;
}
#line 4975 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1821 "conf_parser.y" /* yacc.c:1646  */
    {
  struct ClassItem *class = NULL;

  if (conf_parser_ctx.pass != 1)
    break;

  if (!block_state.class.buf[0])
    break;

  if (!(class = class_find(block_state.class.buf, 0)))
    class = class_make();

  class->active = 1;
  MyFree(class->name);
  class->name = xstrdup(block_state.class.buf);
  class->ping_freq = block_state.ping_freq.value;
  class->max_perip = block_state.max_perip.value;
  class->con_freq = block_state.con_freq.value;
  class->max_total = block_state.max_total.value;
  class->max_global = block_state.max_global.value;
  class->max_local = block_state.max_local.value;
  class->soft_sendq = block_state.soft_sendq.value;
  class->flood_burst = block_state.flood_burst.value;
  class->flood_limit = block_state.flood_limit.value;
  class->max_sendq = block_state.max_sendq.value;
  class->max_recvq = block_state.max_recvq.value;

  if (block_state.min_idle.value > block_state.max_idle.value)
  {
    block_state.min_idle.value = 0;
    block_state.max_idle.value = 0;
    block_state.flags.value &= ~CLASS_FLAGS_FAKE_IDLE;
  }

  class->flags = block_state.flags.value;
  class->min_idle = block_state.min_idle.value;
  class->max_idle = block_state.max_idle.value;
  class->cidr_bitlen_ipv4 = block_state.cidr_bitlen_ipv4.value;
  class->cidr_bitlen_ipv6 = block_state.cidr_bitlen_ipv6.value;
  class->number_per_cidr = block_state.number_per_cidr.value;
  class->max_channels = block_state.max_channels.value;

  rebuild_cidr_list(class);
}
#line 5024 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1884 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    strlcpy(block_state.class.buf, yylval.string, sizeof(block_state.class.buf));
}
#line 5033 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1890 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.ping_freq.value = (yyvsp[-1].number);
}
#line 5042 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1896 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_perip.value = (yyvsp[-1].number);
}
#line 5051 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1902 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.con_freq.value = (yyvsp[-1].number);
}
#line 5060 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1908 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_total.value = (yyvsp[-1].number);
}
#line 5069 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1914 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_global.value = (yyvsp[-1].number);
}
#line 5078 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1920 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_local.value = (yyvsp[-1].number);
}
#line 5087 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1926 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.soft_sendq.value = (yyvsp[-1].number);
}
#line 5096 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1932 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flood_burst.value = (yyvsp[-1].number);
}
#line 5105 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1938 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flood_limit.value = (yyvsp[-1].number);
}
#line 5114 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1944 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_sendq.value = (yyvsp[-1].number);
}
#line 5123 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1950 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    if ((yyvsp[-1].number) >= CLIENT_FLOOD_MIN && (yyvsp[-1].number) <= CLIENT_FLOOD_MAX)
      block_state.max_recvq.value = (yyvsp[-1].number);
}
#line 5133 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1957 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.cidr_bitlen_ipv4.value = (yyvsp[-1].number) > 32 ? 32 : (yyvsp[-1].number);
}
#line 5142 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1963 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.cidr_bitlen_ipv6.value = (yyvsp[-1].number) > 128 ? 128 : (yyvsp[-1].number);
}
#line 5151 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1969 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.number_per_cidr.value = (yyvsp[-1].number);
}
#line 5160 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1975 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  block_state.min_idle.value = (yyvsp[-1].number);
  block_state.flags.value |= CLASS_FLAGS_FAKE_IDLE;
}
#line 5172 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1984 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 1)
    break;

  block_state.max_idle.value = (yyvsp[-1].number);
  block_state.flags.value |= CLASS_FLAGS_FAKE_IDLE;
}
#line 5184 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1993 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.max_channels.value = (yyvsp[-1].number);
}
#line 5193 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1999 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flags.value &= CLASS_FLAGS_FAKE_IDLE;
}
#line 5202 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2006 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flags.value |= CLASS_FLAGS_RANDOM_IDLE;
}
#line 5211 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2010 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 1)
    block_state.flags.value |= CLASS_FLAGS_HIDE_IDLE_FROM_OPERS;
}
#line 5220 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2020 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 5229 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2026 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.flags.value = 0;
  *block_state.profile.buf = 0;
}
#line 5238 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2033 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= LISTENER_SSL;
}
#line 5247 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2037 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= LISTENER_HIDDEN;
}
#line 5256 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2041 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
   block_state.flags.value |= LISTENER_SERVER;
}
#line 5265 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2045 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= LISTENER_HTTP;
}
#line 5274 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2049 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= LISTENER_DEFER;
}
#line 5283 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2058 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.flags.value = 0;
  *block_state.profile.buf = 0;
}
#line 5292 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2066 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    struct sslprofile *profile = NULL;

    if (block_state.flags.value & LISTENER_SSL)
    {
      if (!dlink_list_length(&sslprofile_items))
      {
        conf_error_report("SSL not available - port closed");
        break;
      }

      profile = sslprofile_find(block_state.profile.buf);
    }

    add_listener((yyvsp[0].number), block_state.addr.buf, block_state.flags.value, profile);
  }
}
#line 5316 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2085 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    int i;
    struct sslprofile *profile = NULL;

    if (block_state.flags.value & LISTENER_SSL)
    {
      if (!dlink_list_length(&sslprofile_items))
      {
        conf_error_report("SSL not available - port closed");
        break;
      }

      profile = sslprofile_find(block_state.profile.buf);
    }

    for (i = (yyvsp[-2].number); i <= (yyvsp[0].number); ++i)
      add_listener(i, block_state.addr.buf, block_state.flags.value, profile);
  }
}
#line 5342 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2108 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.addr.buf, yylval.string, sizeof(block_state.addr.buf));
}
#line 5351 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2114 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.addr.buf, yylval.string, sizeof(block_state.addr.buf));
}
#line 5360 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2120 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.profile.buf, yylval.string, sizeof(block_state.profile.buf));
}
#line 5369 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2129 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 5378 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2133 "conf_parser.y" /* yacc.c:1646  */
    {
  dlink_node *ptr = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  DLINK_FOREACH(ptr, block_state.mask.list.head)
  {
    struct MaskItem *conf = NULL;
    struct split_nuh_item nuh;

    nuh.nuhmask  = ptr->data;
    nuh.nickptr  = NULL;
    nuh.userptr  = block_state.user.buf;
    nuh.hostptr  = block_state.host.buf;
    nuh.nicksize = 0;
    nuh.usersize = sizeof(block_state.user.buf);
    nuh.hostsize = sizeof(block_state.host.buf);
    split_nuh(&nuh);

    if (EmptyString(block_state.host.buf))
      continue;

    conf        = conf_make(CONF_CLIENT);
    conf->user  = xstrdup(block_state.user.buf);
    conf->host  = xstrdup(block_state.host.buf);

    if (block_state.rpass.buf[0])
      conf->passwd = xstrdup(block_state.rpass.buf);
    if (block_state.name.buf[0])
      conf->name = xstrdup(block_state.name.buf);

    conf->flags = block_state.flags.value;
    conf->port  = block_state.port.value;

    if (block_state.cert.buf[0])
      conf->certfp = xstrdup(block_state.cert.buf);

    if (block_state.ca.buf[0])
    {
      int ret;

      conf->x509_store = X509_STORE_new();
      ret = X509_STORE_load_locations(conf->x509_store, block_state.ca.buf, NULL);
      if (ret != 1)
      {
        X509_STORE_free(conf->x509_store);
        conf->x509_store = NULL;

        ilog(LOG_TYPE_IRCD, "Unable to load ca_file X509 store %s, ignoring auth block", block_state.ca.buf);
        conf_free(conf);
        continue;
      }
    }

    conf_add_class_to_conf(conf, block_state.class.buf);
    add_conf_by_address(CONF_CLIENT, conf);
  }
}
#line 5442 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 382:
#line 2200 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.mask.list);
}
#line 5451 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2206 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 5460 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2212 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.class.buf, yylval.string, sizeof(block_state.class.buf));
}
#line 5469 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2218 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (yylval.number)
      block_state.flags.value |= CONF_FLAGS_ENCRYPTED;
    else
      block_state.flags.value &= ~CONF_FLAGS_ENCRYPTED;
  }
}
#line 5483 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2229 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value &= (CONF_FLAGS_ENCRYPTED | CONF_FLAGS_SPOOF_IP);
}
#line 5492 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2236 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_SPOOF_NOTICE;
}
#line 5501 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2240 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NOLIMIT;
}
#line 5510 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2244 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_EXEMPTKLINE;
}
#line 5519 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2248 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_EXEMPTDNSBL;
}
#line 5528 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2252 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NEED_IDENTD;
}
#line 5537 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2256 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_CAN_FLOOD;
}
#line 5546 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2260 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NO_TILDE;
}
#line 5555 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2264 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_EXEMPTGLINE;
}
#line 5564 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2268 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_EXEMPTRESV;
}
#line 5573 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2272 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_WEBIRC;
}
#line 5582 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2276 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NEED_ACCOUNT;
}
#line 5591 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2280 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_NEED_PASSWORD;
}
#line 5600 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2286 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (strlen(yylval.string) <= HOSTLEN && valid_hostname(yylval.string))
  {
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
    block_state.flags.value |= CONF_FLAGS_SPOOF_IP;
  }
  else
    ilog(LOG_TYPE_IRCD, "Spoof either is too long or contains invalid characters. Ignoring it.");
}
#line 5617 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2300 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
  block_state.flags.value |= CONF_FLAGS_REDIR;
}
#line 5629 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2309 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  block_state.flags.value |= CONF_FLAGS_REDIR;
  block_state.port.value = (yyvsp[-1].number);
}
#line 5641 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2318 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  strlcpy(block_state.cert.buf, yylval.string, sizeof(block_state.cert.buf));
}
#line 5652 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2326 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  strlcpy(block_state.ca.buf, yylval.string, sizeof(block_state.ca.buf));
}
#line 5663 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2338 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();
  strlcpy(block_state.rpass.buf, CONF_NOREASON, sizeof(block_state.rpass.buf));
}
#line 5675 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2345 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  create_resv(block_state.name.buf, block_state.rpass.buf, &block_state.mask.list);
}
#line 5686 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2356 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 5695 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2362 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 5704 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2368 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.mask.list);
}
#line 5713 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2383 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if (valid_servname(yylval.string))
  {
    struct MaskItem *conf = conf_make(CONF_SERVICE);
    conf->name = xstrdup(yylval.string);
  }
}
#line 5728 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2398 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();

  strlcpy(block_state.name.buf, "*", sizeof(block_state.name.buf));
  strlcpy(block_state.user.buf, "*", sizeof(block_state.user.buf));
  strlcpy(block_state.host.buf, "*", sizeof(block_state.host.buf));
  block_state.flags.value = SHARED_ALL;
}
#line 5744 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2409 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  conf = conf_make(CONF_ULINE);
  conf->flags = block_state.flags.value;
  conf->name = xstrdup(block_state.name.buf);
  conf->user = xstrdup(block_state.user.buf);
  conf->host = xstrdup(block_state.host.buf);
}
#line 5761 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2426 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 5770 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2432 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    struct split_nuh_item nuh;

    nuh.nuhmask  = yylval.string;
    nuh.nickptr  = NULL;
    nuh.userptr  = block_state.user.buf;
    nuh.hostptr  = block_state.host.buf;

    nuh.nicksize = 0;
    nuh.usersize = sizeof(block_state.user.buf);
    nuh.hostsize = sizeof(block_state.host.buf);

    split_nuh(&nuh);
  }
}
#line 5792 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2451 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value = 0;
}
#line 5801 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2458 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_KLINE;
}
#line 5810 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2462 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNKLINE;
}
#line 5819 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2466 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_DLINE;
}
#line 5828 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2470 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNDLINE;
}
#line 5837 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2474 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_XLINE;
}
#line 5846 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2478 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNXLINE;
}
#line 5855 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2482 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_RESV;
}
#line 5864 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2486 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNRESV;
}
#line 5873 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2490 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_LOCOPS;
}
#line 5882 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2494 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_SESSION;
}
#line 5891 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2498 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_WLINE;
}
#line 5900 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2502 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value = SHARED_ALL;
}
#line 5909 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2511 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();

  strlcpy(block_state.name.buf, "*", sizeof(block_state.name.buf));
  block_state.flags.value = SHARED_ALL;
}
#line 5923 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2520 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  conf = conf_make(CONF_CLUSTER);
  conf->flags = block_state.flags.value;
  conf->name = xstrdup(block_state.name.buf);
}
#line 5938 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 457:
#line 2535 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 5947 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 458:
#line 2541 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value = 0;
}
#line 5956 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2548 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_KLINE;
}
#line 5965 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 463:
#line 2552 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNKLINE;
}
#line 5974 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 464:
#line 2556 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_DLINE;
}
#line 5983 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 465:
#line 2560 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNDLINE;
}
#line 5992 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 466:
#line 2564 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_XLINE;
}
#line 6001 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2568 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNXLINE;
}
#line 6010 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 468:
#line 2572 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_RESV;
}
#line 6019 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 469:
#line 2576 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_UNRESV;
}
#line 6028 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 470:
#line 2580 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= SHARED_LOCOPS;
}
#line 6037 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 471:
#line 2584 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value = SHARED_ALL;
}
#line 6046 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 472:
#line 2593 "conf_parser.y" /* yacc.c:1646  */
    {

  if (conf_parser_ctx.pass != 2)
    break;

  reset_block_state();
  block_state.aftype.value = AF_INET;
  block_state.port.value = PORTNUM;
}
#line 6060 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 473:
#line 2602 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;
  struct addrinfo hints, *res;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.name.buf[0] ||
      !block_state.host.buf[0])
    break;

  if (!block_state.rpass.buf[0] ||
      !block_state.spass.buf[0])
    break;

  if (has_wildcards(block_state.name.buf))
    break;

  conf = conf_make(CONF_SERVER);
  conf->port = block_state.port.value;
  conf->flags = block_state.flags.value;
  conf->aftype = block_state.aftype.value;
  conf->host = xstrdup(block_state.host.buf);
  conf->name = xstrdup(block_state.name.buf);
  conf->passwd = xstrdup(block_state.rpass.buf);
  conf->spasswd = xstrdup(block_state.spass.buf);

  if (block_state.cert.buf[0])
    conf->certfp = xstrdup(block_state.cert.buf);

  dlinkMoveList(&block_state.leaf.list, &conf->leaf_list);
  dlinkMoveList(&block_state.hub.list, &conf->hub_list);

  if (block_state.bind.buf[0])
  {
    memset(&hints, 0, sizeof(hints));

    hints.ai_family   = AF_UNSPEC;
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_flags    = AI_PASSIVE | AI_NUMERICHOST;

    if (getaddrinfo(block_state.bind.buf, NULL, &hints, &res))
      ilog(LOG_TYPE_IRCD, "Invalid netmask for server vhost(%s)", block_state.bind.buf);
    else
    {
      assert(res != NULL);

      memcpy(&conf->bind, res->ai_addr, res->ai_addrlen);
      conf->bind.ss.ss_family = res->ai_family;
      conf->bind.ss_len = res->ai_addrlen;
      freeaddrinfo(res);
    }
  }

  if (block_state.ca.buf[0])
  {
    int ret;

    conf->x509_store = X509_STORE_new();
    ret = X509_STORE_load_locations(conf->x509_store, block_state.ca.buf, NULL);
    if (ret != 1)
    {
      X509_STORE_free(conf->x509_store);
      conf->x509_store = NULL;

      ilog(LOG_TYPE_IRCD, "Unable to load ca_file X509 store %s, ignoring connect block", block_state.ca.buf);
      conf_free(conf);
      break;
    }
  }

  conf->ssl_profile = xstrdup(block_state.profile.buf);

  conf_add_class_to_conf(conf, block_state.class.buf);
  lookup_confhost(conf);
}
#line 6141 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2689 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 6150 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2695 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.host.buf, yylval.string, sizeof(block_state.host.buf));
}
#line 6159 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2701 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.bind.buf, yylval.string, sizeof(block_state.bind.buf));
}
#line 6168 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2707 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].string)[0] == ':')
    conf_error_report("Server passwords cannot begin with a colon");
  else if (strchr((yyvsp[-1].string), ' ') != NULL)
    conf_error_report("Server passwords cannot contain spaces");
  else
    strlcpy(block_state.spass.buf, yylval.string, sizeof(block_state.spass.buf));
}
#line 6184 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2720 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass != 2)
    break;

  if ((yyvsp[-1].string)[0] == ':')
    conf_error_report("Server passwords cannot begin with a colon");
  else if (strchr((yyvsp[-1].string), ' ') != NULL)
    conf_error_report("Server passwords cannot contain spaces");
  else
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 6200 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2733 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.cert.buf, yylval.string, sizeof(block_state.cert.buf));
}
#line 6209 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2739 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.ca.buf, yylval.string, sizeof(block_state.ca.buf));
}
#line 6218 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 499:
#line 2745 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.profile.buf, yylval.string, sizeof(block_state.profile.buf));
}
#line 6227 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2751 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.port.value = (yyvsp[-1].number);
}
#line 6236 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2757 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.aftype.value = AF_INET;
}
#line 6245 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2761 "conf_parser.y" /* yacc.c:1646  */
    {
#ifdef IPV6
  if (conf_parser_ctx.pass == 2)
    block_state.aftype.value = AF_INET6;
#endif
}
#line 6256 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2769 "conf_parser.y" /* yacc.c:1646  */
    {
  block_state.flags.value &= CONF_FLAGS_ENCRYPTED;
}
#line 6264 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 507:
#line 2775 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_ALLOW_AUTO_CONN;
}
#line 6273 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 508:
#line 2779 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    block_state.flags.value |= CONF_FLAGS_SSL;
}
#line 6282 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 509:
#line 2785 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (yylval.number)
      block_state.flags.value |= CONF_FLAGS_ENCRYPTED;
    else
      block_state.flags.value &= ~CONF_FLAGS_ENCRYPTED;
  }
}
#line 6296 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 510:
#line 2796 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.hub.list);
}
#line 6305 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2802 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    dlinkAdd(xstrdup(yylval.string), make_dlink_node(), &block_state.leaf.list);
}
#line 6314 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2808 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.class.buf, yylval.string, sizeof(block_state.class.buf));
}
#line 6323 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2818 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 6332 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2822 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.user.buf[0] ||
      !block_state.host.buf[0])
    break;

  conf = conf_make(CONF_KLINE);
  conf->user = xstrdup(block_state.user.buf);
  conf->host = xstrdup(block_state.host.buf);

  if (block_state.rpass.buf[0])
    conf->reason = xstrdup(block_state.rpass.buf);
  else
    conf->reason = xstrdup(CONF_NOREASON);
  add_conf_by_address(CONF_KLINE, conf);
}
#line 6357 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2847 "conf_parser.y" /* yacc.c:1646  */
    {

  if (conf_parser_ctx.pass == 2)
  {
    struct split_nuh_item nuh;

    nuh.nuhmask  = yylval.string;
    nuh.nickptr  = NULL;
    nuh.userptr  = block_state.user.buf;
    nuh.hostptr  = block_state.host.buf;

    nuh.nicksize = 0;
    nuh.usersize = sizeof(block_state.user.buf);
    nuh.hostsize = sizeof(block_state.host.buf);

    split_nuh(&nuh);
  }
}
#line 6380 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2867 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 6389 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2876 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 6398 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2880 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.addr.buf[0])
    break;

  if (parse_netmask(block_state.addr.buf, NULL, NULL) != HM_HOST)
  {
    conf = conf_make(CONF_DLINE);
    conf->host = xstrdup(block_state.addr.buf);

    if (block_state.rpass.buf[0])
      conf->reason = xstrdup(block_state.rpass.buf);
    else
      conf->reason = xstrdup(CONF_NOREASON);
    add_conf_by_address(CONF_DLINE, conf);
  }
}
#line 6424 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 529:
#line 2906 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.addr.buf, yylval.string, sizeof(block_state.addr.buf));
}
#line 6433 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 530:
#line 2912 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 6442 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 536:
#line 2926 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (yylval.string[0] && parse_netmask(yylval.string, NULL, NULL) != HM_HOST)
    {
      struct MaskItem *conf = conf_make(CONF_EXEMPT);
      conf->host = xstrdup(yylval.string);

      add_conf_by_address(CONF_EXEMPT, conf);
    }
  }
}
#line 6459 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2943 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    reset_block_state();
}
#line 6468 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2947 "conf_parser.y" /* yacc.c:1646  */
    {
  struct MaskItem *conf = NULL;

  if (conf_parser_ctx.pass != 2)
    break;

  if (!block_state.name.buf[0])
    break;

  conf = conf_make(CONF_XLINE);
  conf->name = xstrdup(block_state.name.buf);

  if (block_state.rpass.buf[0])
    conf->reason = xstrdup(block_state.rpass.buf);
  else
    conf->reason = xstrdup(CONF_NOREASON);
}
#line 6490 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2969 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.name.buf, yylval.string, sizeof(block_state.name.buf));
}
#line 6499 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2975 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    strlcpy(block_state.rpass.buf, yylval.string, sizeof(block_state.rpass.buf));
}
#line 6508 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 614:
#line 3024 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_watch = (yyvsp[-1].number);
}
#line 6516 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 615:
#line 3029 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.cycle_on_host_change = yylval.number;
}
#line 6525 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 616:
#line 3035 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.cloak_key);
    ConfigFileEntry.cloak_key = xstrdup(yylval.string);
  }
}
#line 6537 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 617:
#line 3044 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.account_whois = yylval.number;
}
#line 6546 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 618:
#line 3050 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.glines = yylval.number;
}
#line 6555 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 619:
#line 3056 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.gline_time = (yyvsp[-1].number);
}
#line 6564 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 620:
#line 3062 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.gline_request_time = (yyvsp[-1].number);
}
#line 6573 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 621:
#line 3068 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.gline_min_cidr = (yyvsp[-1].number);
}
#line 6581 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 622:
#line 3073 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.gline_min_cidr6 = (yyvsp[-1].number);
}
#line 6589 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 623:
#line 3078 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.kline_reason);
    ConfigFileEntry.kline_reason = xstrdup(yylval.string);
  }
}
#line 6601 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 624:
#line 3087 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.tkline_expire_notices = yylval.number;
}
#line 6609 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 625:
#line 3092 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.kill_chase_time_limit = (yyvsp[-1].number);
}
#line 6617 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 626:
#line 3097 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.hide_spoof_ips = yylval.number;
}
#line 6625 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 627:
#line 3102 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.ignore_bogus_ts = yylval.number;
}
#line 6633 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 628:
#line 3107 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.failed_oper_notice = yylval.number;
}
#line 6641 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 629:
#line 3112 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.anti_nick_flood = yylval.number;
}
#line 6649 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 630:
#line 3117 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_nick_time = (yyvsp[-1].number);
}
#line 6657 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 631:
#line 3122 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_nick_changes = (yyvsp[-1].number);
}
#line 6665 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 632:
#line 3127 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_accept = (yyvsp[-1].number);
}
#line 6673 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 633:
#line 3132 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.anti_spam_exit_message_time = (yyvsp[-1].number);
}
#line 6681 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 634:
#line 3137 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.ts_warn_delta = (yyvsp[-1].number);
}
#line 6689 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 635:
#line 3142 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigFileEntry.ts_max_delta = (yyvsp[-1].number);
}
#line 6698 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 636:
#line 3148 "conf_parser.y" /* yacc.c:1646  */
    {
  if (((yyvsp[-1].number) > 0) && conf_parser_ctx.pass == 1)
  {
    ilog(LOG_TYPE_IRCD, "You haven't read your config file properly.");
    ilog(LOG_TYPE_IRCD, "There is a line in the example conf that will kill your server if not removed.");
    ilog(LOG_TYPE_IRCD, "Consider actually reading/editing the conf file, and removing this line.");
    exit(0);
  }
}
#line 6712 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 637:
#line 3159 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.invisible_on_connect = yylval.number;
}
#line 6720 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 638:
#line 3164 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.warn_no_nline = yylval.number;
}
#line 6728 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 639:
#line 3169 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_e_disabled = yylval.number;
}
#line 6736 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 640:
#line 3174 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_o_oper_only = yylval.number;
}
#line 6744 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 641:
#line 3179 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_P_oper_only = yylval.number;
}
#line 6752 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 642:
#line 3184 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_u_oper_only = yylval.number;
}
#line 6760 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 643:
#line 3189 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_k_oper_only = 2 * yylval.number;
}
#line 6768 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 644:
#line 3192 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_k_oper_only = 1;
}
#line 6776 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 645:
#line 3197 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_i_oper_only = 2 * yylval.number;
}
#line 6784 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 646:
#line 3200 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_i_oper_only = 1;
}
#line 6792 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 647:
#line 3205 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.stats_m_oper_only = yylval.number;
}
#line 6800 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 648:
#line 3210 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.pace_wait = (yyvsp[-1].number);
}
#line 6808 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 649:
#line 3215 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.caller_id_wait = (yyvsp[-1].number);
}
#line 6816 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 650:
#line 3220 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.opers_bypass_callerid = yylval.number;
}
#line 6824 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 651:
#line 3225 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.pace_wait_simple = (yyvsp[-1].number);
}
#line 6832 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 652:
#line 3230 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.short_motd = yylval.number;
}
#line 6840 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 653:
#line 3235 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.no_oper_flood = yylval.number;
}
#line 6848 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 654:
#line 3240 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_pass_resv = yylval.number;
}
#line 6856 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 655:
#line 3245 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.dots_in_ident = (yyvsp[-1].number);
}
#line 6864 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 656:
#line 3250 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.max_targets = (yyvsp[-1].number);
}
#line 6872 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 657:
#line 3255 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2 && valid_servname(yylval.string))
  {
    MyFree(ConfigFileEntry.service_name);
    ConfigFileEntry.service_name = xstrdup(yylval.string);
  }
}
#line 6884 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 658:
#line 3264 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.sasl_name);
    ConfigFileEntry.sasl_name = xstrdup(yylval.string);
  }
}
#line 6896 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 659:
#line 3273 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.ping_cookie = yylval.number;
}
#line 6904 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 660:
#line 3278 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.nick_collide_realhost = yylval.number;
}
#line 6912 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 661:
#line 3283 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.disable_auth = yylval.number;
}
#line 6920 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 662:
#line 3288 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.throttle_num = yylval.number;
}
#line 6928 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 663:
#line 3293 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.throttle_time = (yyvsp[-1].number);
}
#line 6936 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 664:
#line 3298 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes = 0;
}
#line 6944 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 666:
#line 3303 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.enable_extbans = yylval.number;
}
#line 6952 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 667:
#line 3308 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.enable_forwarding = yylval.number;
}
#line 6960 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 668:
#line 3313 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if ((ConfigFileEntry.message_digest_algorithm = EVP_get_digestbyname(yylval.string)) == NULL)
    {
      ConfigFileEntry.message_digest_algorithm = EVP_sha1();
      conf_error_report("Ignoring general::ssl_message_digest_algorithm -- unknown message digest algorithm");
    }
  }
}
#line 6975 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 669:
#line 3325 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.mass_highlight_nicks = (yyvsp[-1].number);
}
#line 6983 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 670:
#line 3330 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.delay_secs = (yyvsp[-1].number);
}
#line 6991 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 671:
#line 3335 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.delay_message_count = (yyvsp[-1].number);
}
#line 6999 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 672:
#line 3340 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.delay_signon_secs = (yyvsp[-1].number);
}
#line 7007 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 675:
#line 3346 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_NOCTCP;
}
#line 7015 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 676:
#line 3350 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_DEAF;
}
#line 7023 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 677:
#line 3354 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_HIDECHANNELS;
}
#line 7031 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 678:
#line 3358 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_OPERWALL;
}
#line 7039 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 679:
#line 3362 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_SERVNOTICE;
}
#line 7047 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 680:
#line 3366 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_INVISIBLE;
}
#line 7055 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 681:
#line 3370 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_WALLOP;
}
#line 7063 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 682:
#line 3374 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_SOFTCALLERID;
}
#line 7071 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 683:
#line 3378 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_CALLERID;
}
#line 7079 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 684:
#line 3382 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_LOCOPS;
}
#line 7087 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 685:
#line 3386 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_REGONLY;
}
#line 7095 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 686:
#line 3390 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_umodes |= UMODE_SPY;
}
#line 7103 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 687:
#line 3395 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local = ConfigFileEntry.oper_snomasks.remote = 0;
}
#line 7111 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 691:
#line 3402 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.remote |= sno_bots.flag;
}
#line 7119 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 692:
#line 3406 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_bots.flag;
}
#line 7127 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 693:
#line 3410 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.remote |= sno_cconn.flag;
}
#line 7135 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 694:
#line 3414 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_cconn.flag;
}
#line 7143 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 695:
#line 3418 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_debug.flag;
}
#line 7151 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 696:
#line 3422 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_nchange.flag;
}
#line 7159 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 697:
#line 3426 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_full.flag;
}
#line 7167 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 698:
#line 3430 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_skill.flag;
}
#line 7175 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 699:
#line 3434 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_rej.flag;
}
#line 7183 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 700:
#line 3438 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_unauth.flag;
}
#line 7191 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 701:
#line 3442 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_spy.flag;
}
#line 7199 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 702:
#line 3446 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.remote |= sno_link.flag;
}
#line 7207 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 703:
#line 3450 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_snomasks.local |= sno_link.flag;
}
#line 7215 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 704:
#line 3455 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes = 0;
}
#line 7223 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 708:
#line 3461 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_NOCTCP;
}
#line 7231 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 709:
#line 3465 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_DEAF;
}
#line 7239 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 710:
#line 3469 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_HIDECHANNELS;
}
#line 7247 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 711:
#line 3473 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_OPERWALL;
}
#line 7255 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 712:
#line 3477 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_SERVNOTICE;
}
#line 7263 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 713:
#line 3481 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_INVISIBLE;
}
#line 7271 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 714:
#line 3485 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_WALLOP;
}
#line 7279 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 715:
#line 3489 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_SOFTCALLERID;
}
#line 7287 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 716:
#line 3493 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_CALLERID;
}
#line 7295 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 717:
#line 3497 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_LOCOPS;
}
#line 7303 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 718:
#line 3501 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_REGONLY;
}
#line 7311 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 719:
#line 3505 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.oper_only_umodes |= UMODE_SPY;
}
#line 7319 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 720:
#line 3510 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigFileEntry.disable_chmodes);
    ConfigFileEntry.disable_chmodes = xstrdup(yylval.string);
  }
}
#line 7331 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 721:
#line 3519 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.use_target_change = yylval.number;
}
#line 7339 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 722:
#line 3524 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.min_nonwildcard = (yyvsp[-1].number);
}
#line 7347 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 723:
#line 3529 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.min_nonwildcard_simple = (yyvsp[-1].number);
}
#line 7355 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 724:
#line 3534 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.default_floodcount = (yyvsp[-1].number);
}
#line 7363 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 725:
#line 3539 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigFileEntry.default_floodtime = (yyvsp[-1].number);
}
#line 7371 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 743:
#line 3563 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.disable_fake_channels = yylval.number;
}
#line 7379 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 744:
#line 3568 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.knock_delay = (yyvsp[-1].number);
}
#line 7387 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 745:
#line 3573 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.knock_delay_channel = (yyvsp[-1].number);
}
#line 7395 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 746:
#line 3578 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.max_chans_per_user = (yyvsp[-1].number);
}
#line 7403 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 747:
#line 3583 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.max_bans = (yyvsp[-1].number);
}
#line 7411 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 748:
#line 3588 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.default_split_user_count = (yyvsp[-1].number);
}
#line 7419 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 749:
#line 3593 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.default_split_server_count = (yyvsp[-1].number);
}
#line 7427 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 750:
#line 3598 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.no_create_on_split = yylval.number;
}
#line 7435 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 751:
#line 3603 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.no_join_on_split = yylval.number;
}
#line 7443 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 752:
#line 3608 "conf_parser.y" /* yacc.c:1646  */
    {
  GlobalSetOptions.joinfloodcount = yylval.number;
}
#line 7451 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 753:
#line 3613 "conf_parser.y" /* yacc.c:1646  */
    {
  GlobalSetOptions.joinfloodtime = (yyvsp[-1].number);
}
#line 7459 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 754:
#line 3618 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.quiet_on_ban = yylval.number;
}
#line 7467 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 755:
#line 3623 "conf_parser.y" /* yacc.c:1646  */
    {
  ConfigChannel.invite_throttle = (yyvsp[-1].number);
}
#line 7475 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 768:
#line 3643 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.flatten_links = yylval.number;
}
#line 7484 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 769:
#line 3649 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.disable_remote_commands = yylval.number;
}
#line 7493 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 770:
#line 3655 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.hide_servers = yylval.number;
}
#line 7502 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 771:
#line 3661 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.hide_services = yylval.number;
}
#line 7511 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 772:
#line 3667 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    MyFree(ConfigServerHide.hidden_name);
    ConfigServerHide.hidden_name = xstrdup(yylval.string);
  }
}
#line 7523 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 773:
#line 3676 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
  {
    if (((yyvsp[-1].number) > 0) && ConfigServerHide.links_disabled == 1)
    {
      eventAddIsh("write_links_file", write_links_file, NULL, (yyvsp[-1].number));
      ConfigServerHide.links_disabled = 0;
    }

    ConfigServerHide.links_delay = (yyvsp[-1].number);
  }
}
#line 7540 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 774:
#line 3690 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.hidden = yylval.number;
}
#line 7549 "conf_parser.c" /* yacc.c:1646  */
    break;

  case 775:
#line 3696 "conf_parser.y" /* yacc.c:1646  */
    {
  if (conf_parser_ctx.pass == 2)
    ConfigServerHide.hide_server_ips = yylval.number;
}
#line 7558 "conf_parser.c" /* yacc.c:1646  */
    break;


#line 7562 "conf_parser.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
